/* mvt.f -- translated by f2c (version 19980831 for lcc-win32).
   You must link the resulting object file with the library:
 libf77.lib 
*/

#include <f2c.h>
#include <windows.h>
#include <math.h>
#include <malloc.h>


/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;
static doublereal c_b9 = 1.;
static integer c__8000 = 8000;
static integer c__2 = 2;
static integer c__4 = 4;


//
//  FUNCTION: DLLMain(HINSTANCE, DWORD, LPVOID)
//  PURPOSE:  Called when DLL is loaded by a process, and when new
//    threads are created by a process that has already loaded the
//    DLL.  Also called when threads of a process that has loaded the
//    DLL exit cleanly and when the process itself unloads the DLL.
//  PARAMETERS:
//    hDLLInst    - Instance handle of the DLL
//    fdwReason   - Process attach/detach or thread attach/detach
//    lpvReserved - Reserved and not used
//  RETURN VALUE:  (Used only when fdwReason == DLL_PROCESS_ATTACH)
//    TRUE  -  Used to signify that the DLL should remain loaded.
//    FALSE -  Used to signify that the DLL should be immediately unloaded.
//

BOOL WINAPI LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // The DLL is being loaded for the first time by a given process.
            // Perform per-process initialization here.  If the initialization
            // is successful, return TRUE; if unsuccessful, return FALSE.


            break;
        case DLL_PROCESS_DETACH:
            // The DLL is being unloaded by a given process.  Do any
            // per-process clean up here, such as undoing what was done in
            // DLL_PROCESS_ATTACH.  The return value is ignored.


            break;
        case DLL_THREAD_ATTACH:
            // A thread is being created in a process that has already loaded
            // this DLL.  Perform any per-thread initialization here.  The
            // return value is ignored.

            break;
        case DLL_THREAD_DETACH:
            // A thread is exiting cleanly in a process that has already
            // loaded this DLL.  Perform any per-thread clean up here.  The
            // return value is ignored.

            break;
    }
    return TRUE;
}

		
int ranmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__);

int kromvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__);
	
int sadmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__);
	
int sphmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__);	

__declspec(dllexport) int dllranmvt(double *_m, double *_n, double *_nu, double *_lower, 
	                                double *_upper, double *_infin, double *_correl, 
								    double *_maxpts, double *_abseps, double *_releps,
								    double *_error, double *_value, double *_inform__)
{
    int m, n, nu, *infin, maxpts, inform__;	
	double *lower, *upper, error, value;	
	int i, j;
	
	/* cast */
	m        = (int) *_m;
	n        = (int) *_n;
	nu       = (int) *_nu;
	maxpts   = (int) *_maxpts;

	lower = (double*) malloc(n*sizeof(double));	
	upper = (double*) malloc(n*sizeof(double));	
	infin = (int*) malloc(n*sizeof(int));	
	
	for (j=0;j<m;j++)
	{
		for (i=0;i<n;i++)
		{
			lower[i] = (double) _lower[j*n+i];
			upper[i] = (double) _upper[j*n+i];
			infin[i] = (int) _infin[j*n+i];
		}
			
		ranmvt_(&n, &nu, lower, upper, infin, _correl,
		        &maxpts, _abseps, _releps, &error, &value, &inform__);
		
		_error[j] = error;
		_value[j] = value;
		_inform__[j] = (double) inform__;
	
	}
	
	free(lower);
	free(upper);
    free(infin);

	return(0);
}


__declspec(dllexport) int dllkromvt(double *_m, double *_n, double *_nu, double *_lower, 
	                                double *_upper, double *_infin, double *_correl, 
								    double *_maxpts, double *_abseps, double *_releps,
								    double *_error, double *_value, double *_inform__)
{
    int m, n, nu, *infin, maxpts, inform__;	
	double *lower, *upper, error, value;	
	int i, j;
	
	/* cast */
	m        = (int) *_m;
	n        = (int) *_n;
	nu       = (int) *_nu;
	maxpts   = (int) *_maxpts;

	lower = (double*) malloc(n*sizeof(double));	
	upper = (double*) malloc(n*sizeof(double));	
	infin = (int*) malloc(n*sizeof(int));	
	
	for (j=0;j<m;j++)
	{
		for (i=0;i<n;i++)
		{
			lower[i] = (double) _lower[j*n+i];
			upper[i] = (double) _upper[j*n+i];
			infin[i] = (int) _infin[j*n+i];
		}
			
		kromvt_(&n, &nu, lower, upper, infin, _correl,
		        &maxpts, _abseps, _releps, &error, &value, &inform__);
		
		_error[j] = error;
		_value[j] = value;
		_inform__[j] = (double) inform__;
	
	}
	
	free(lower);
	free(upper);
    free(infin);

	return(0);
}


__declspec(dllexport) int dllsadmvt(double *_m, double *_n, double *_nu, double *_lower, 
	                                double *_upper, double *_infin, double *_correl, 
								    double *_maxpts, double *_abseps, double *_releps,
								    double *_error, double *_value, double *_inform__)
{
    int m, n, nu, *infin, maxpts, inform__;	
	double *lower, *upper, error, value;	
	int i, j;
	
	/* cast */
	m        = (int) *_m;
	n        = (int) *_n;
	nu       = (int) *_nu;
	maxpts   = (int) *_maxpts;

	lower = (double*) malloc(n*sizeof(double));	
	upper = (double*) malloc(n*sizeof(double));	
	infin = (int*) malloc(n*sizeof(int));	
	
	for (j=0;j<m;j++)
	{
		for (i=0;i<n;i++)
		{
			lower[i] = (double) _lower[j*n+i];
			upper[i] = (double) _upper[j*n+i];
			infin[i] = (int) _infin[j*n+i];
		}
			
		sadmvt_(&n, &nu, lower, upper, infin, _correl,
		        &maxpts, _abseps, _releps, &error, &value, &inform__);
		
		_error[j] = error;
		_value[j] = value;
		_inform__[j] = (double) inform__;
	
	}
	
	free(lower);
	free(upper);
    free(infin);

	return(0);
}


__declspec(dllexport) int dllsphmvt(double *_m, double *_n, double *_nu, double *_lower, 
	                                double *_upper, double *_infin, double *_correl, 
								    double *_maxpts, double *_abseps, double *_releps,
								    double *_error, double *_value, double *_inform__)
{
    int m, n, nu, *infin, maxpts, inform__;	
	double *lower, *upper, error, value;	
	int i, j;
	
	/* cast */
	m        = (int) *_m;
	n        = (int) *_n;
	nu       = (int) *_nu;
	maxpts   = (int) *_maxpts;

	lower = (double*) malloc(n*sizeof(double));	
	upper = (double*) malloc(n*sizeof(double));	
	infin = (int*) malloc(n*sizeof(int));	
	
	for (j=0;j<m;j++)
	{
		for (i=0;i<n;i++)
		{
			lower[i] = (double) _lower[j*n+i];
			upper[i] = (double) _upper[j*n+i];
			infin[i] = (int) _infin[j*n+i];
		}
			
		sphmvt_(&n, &nu, lower, upper, infin, _correl,
		        &maxpts, _abseps, _releps, &error, &value, &inform__);
		
		_error[j] = error;
		_value[j] = value;
		_inform__[j] = (double) inform__;
	
	}
	
	free(lower);
	free(upper);
    free(infin);

	return(0);
}


/* Subroutine */ int ranmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1, d__2;

    /* Local variables */
    static integer ivls;
    static doublereal d__, e;
    static integer infis;
    extern /* Subroutine */ int rcrude_(integer *, integer *, U_fp, 
	    doublereal *, doublereal *, integer *);
    extern /* Subroutine */ int fncmvt_();
    extern doublereal mvtnit_(integer *, integer *, doublereal *, doublereal *
	    , doublereal *, integer *, integer *, doublereal *, doublereal *);
    static doublereal eps;
    static integer mpt;


/*     A subroutine for computing multivariate t probabilities. */
/*          Alan Genz */
/*          Department of Mathematics */
/*          Washington State University */
/*          Pullman, WA 99164-3113 */
/*          Email : AlanGenz@wsu.edu */

/*  Parameters */

/*     N      INTEGER, the number of variables. */
/*     NU     INTEGER, the number of degrees of freedom. */
/*     LOWER  REAL, array of lower integration limits. */
/*     UPPER  REAL, array of upper integration limits. */
/*     INFIN  INTEGER, array of integration limits flags: */
/*            if INFIN(I) < 0, Ith limits are (-infinity, infinity); */
/*            if INFIN(I) = 0, Ith limits are (-infinity, UPPER(I)]; */
/*            if INFIN(I) = 1, Ith limits are [LOWER(I), infinity); */
/*            if INFIN(I) = 2, Ith limits are [LOWER(I), UPPER(I)]. */
/*     CORREL REAL, array of correlation coefficients; the correlation */
/*            coefficient in row I column J of the correlation matrix */
/*            should be stored in CORREL( J + ((I-2)*(I-1))/2 ), for J < I. */
/*     MAXPTS INTEGER, maximum number of function values allowed. This */
/*            parameter can be used to limit the time taken. A sensible */
/*            strategy is to start with MAXPTS = 1000*N, and then */
/*            increase MAXPTS if ERROR is too large. */
/*     ABSEPS REAL absolute error tolerance. */
/*     RELEPS REAL relative error tolerance. */
/*     ERROR  REAL, estimated absolute error, with 99% confidence level. */
/*     VALUE  REAL, estimated value for the integral */
/*     INFORM INTEGER, termination status parameter: */
/*            if INFORM = 0, normal completion with ERROR < EPS; */
/*            if INFORM = 1, completion with ERROR > EPS and MAXPTS */
/*                           function vaules used; increase MAXPTS to */
/*                           decrease ERROR; */
/*            if INFORM = 2, N > 20 or N < 1. */

    /* Parameter adjustments */
    --correl;
    --infin;
    --upper;
    --lower;

    /* Function Body */
    if (*n > 20 || *n < 1) {
	*inform__ = 2;
	*value = 0.;
	*error = 1.;
	return 0;
    }
    *inform__ = (integer) mvtnit_(n, nu, &correl[1], &lower[1], &upper[1], &
	    infin[1], &infis, &d__, &e);
    if (*n - infis == 0) {
	*value = 1.;
	*error = 0.;
    } else if (*n - infis == 1) {
	*value = e - d__;
	*error = 2e-16f;
    } else {

/*        Call then Monte-Carlo integration subroutine */

	mpt = *n * 10 * *n + 25;
	i__1 = *n - infis - 1;
	rcrude_(&i__1, &mpt, (U_fp)fncmvt_, error, value, &c__0);
	ivls = mpt;
L10:
/* Computing MAX */
	d__1 = *abseps, d__2 = *releps * abs(*value);
	eps = max(d__1,d__2);
	if (*error > eps && ivls < *maxpts) {
/* Computing MAX */
/* Computing MIN */
/* Computing 2nd power */
	    d__1 = *error / eps;
	    i__2 = (integer) (mpt * (d__1 * d__1)), i__3 = *maxpts - ivls;
	    i__1 = min(i__2,i__3);
	    mpt = max(i__1,10);
	    i__1 = *n - infis - 1;
	    rcrude_(&i__1, &mpt, (U_fp)fncmvt_, error, value, &c__1);
	    ivls += mpt;
	    goto L10;
	}
	if (*error > eps && ivls >= *maxpts) {
	    *inform__ = 1;
	}
    }
    return 0;
} /* ranmvt_ */

/* Subroutine */ int rcrude_(integer *ndim, integer *maxpts, D_fp functn, 
	doublereal *absest, doublereal *finest, integer *ir)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer npts, k, m;
    static doublereal x[100], findif, finval, varprd, varest, varsqr, fun;
    extern doublereal uni_(void);


/*     Crude Monte-Carlo Algorithm with simple antithetic variates */
/*      and weighted results on restart */

    if (*ir <= 0) {
	varest = 0.;
	*finest = 0.;
    }
    finval = 0.;
    varsqr = 0.;
    npts = *maxpts / 2;
    i__1 = npts;
    for (m = 1; m <= i__1; ++m) {
	i__2 = *ndim;
	for (k = 1; k <= i__2; ++k) {
	    x[k - 1] = uni_();
	}
	fun = (*functn)(ndim, x);
	i__2 = *ndim;
	for (k = 1; k <= i__2; ++k) {
	    x[k - 1] = 1 - x[k - 1];
	}
	fun = ((*functn)(ndim, x) + fun) / 2;
	findif = (fun - finval) / m;
/* Computing 2nd power */
	d__1 = findif;
	varsqr = (m - 2) * varsqr / m + d__1 * d__1;
	finval += findif;
    }
    varprd = varest * varsqr;
    *finest += (finval - *finest) / (varprd + 1);
    if (varsqr > 0.) {
	varest = (varprd + 1) / varsqr;
    }
    *absest = sqrt(varsqr / (varprd + 1)) * 3;
    return 0;
} /* rcrude_ */


/* Subroutine */ int kromvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer ivls;
    static doublereal d__, e;
    static integer infis;
    extern /* Subroutine */ int fncmvt_();
    extern /* Subroutine */ int krobov_(integer *, integer *, integer *, U_fp,
	     doublereal *, doublereal *, doublereal *, doublereal *, integer *
	    );
    extern doublereal mvtnit_(integer *, integer *, doublereal *, doublereal *
	    , doublereal *, integer *, integer *, doublereal *, doublereal *);


/*     A subroutine for computing multivariate t probabilities. */
/*          Alan Genz */
/*          Department of Mathematics */
/*          Washington State University */
/*          Pullman, WA 99164-3113 */
/*          Email : AlanGenz@wsu.edu */

/*  Parameters */

/*     N      INTEGER, the number of variables. */
/*     NU     INTEGER, the number of degrees of freedom. */
/*     LOWER  REAL, array of lower integration limits. */
/*     UPPER  REAL, array of upper integration limits. */
/*     INFIN  INTEGER, array of integration limits flags: */
/*            if INFIN(I) < 0, Ith limits are (-infinity, infinity); */
/*            if INFIN(I) = 0, Ith limits are (-infinity, UPPER(I)]; */
/*            if INFIN(I) = 1, Ith limits are [LOWER(I), infinity); */
/*            if INFIN(I) = 2, Ith limits are [LOWER(I), UPPER(I)]. */
/*     CORREL REAL, array of correlation coefficients; the correlation */
/*            coefficient in row I column J of the correlation matrix */
/*            should be stored in CORREL( J + ((I-2)*(I-1))/2 ), for J < I. */
/*     MAXPTS INTEGER, maximum number of function values allowed. This */
/*            parameter can be used to limit the time. A sensible */
/*            strategy is to start with MAXPTS = 1000*N, and then */
/*            increase MAXPTS if ERROR is too large. */
/*     ABSEPS    REAL absolute error tolerance. */
/*     RELEPS    REAL relative error tolerance. */
/*     ERROR  REAL estimated absolute error, with 99% confidence level. */
/*     VALUE  REAL estimated value for the integral */
/*     INFORM INTEGER, termination status parameter: */
/*            if INFORM = 0, normal completion with ERROR < EPS; */
/*            if INFORM = 1, completion with ERROR > EPS and MAXPTS */
/*                           function vaules used; increase MAXPTS to */
/*                           decrease ERROR; */
/*            if INFORM = 2, N > 20 or N < 1. */

    /* Parameter adjustments */
    --correl;
    --infin;
    --upper;
    --lower;

    /* Function Body */
    if (*n > 20 || *n < 1) {
	*inform__ = 2;
	*value = 0.;
	*error = 1.;
	return 0;
    }
    *inform__ = (integer) mvtnit_(n, nu, &correl[1], &lower[1], &upper[1], &
	    infin[1], &infis, &d__, &e);
    if (*n - infis == 0) {
	*value = 1.;
	*error = 0.;
    } else if (*n - infis == 1) {
	*value = e - d__;
	*error = 2e-16f;
    } else {

/*        Call the lattice rule integration integration subroutine */

	ivls = 0;
	i__1 = *n - infis - 1;
	krobov_(&i__1, &ivls, maxpts, (U_fp)fncmvt_, abseps, releps, error, 
		value, inform__);
    }
    return 0;
} /* kromvt_ */

/* Subroutine */ int krobov_(integer *ndim, integer *minvls, integer *maxvls, 
	D_fp functn, doublereal *abseps, doublereal *releps, doublereal *
	abserr, doublereal *finest, integer *ifail)
{
    /* Initialized data */

    static integer p[17] = { 173,263,397,593,887,1327,1997,2999,4493,6737,
	    10111,15161,22751,34127,51193,76801,115183 };
    static integer c__[680]	/* was [17][40] */ = { 73,111,163,229,192,513,
	    839,1148,1360,2602,3071,6280,9438,12543,19397,22500,33681,34,106,
	    168,40,424,195,146,1406,383,2818,3114,2350,3557,7726,10691,16187,
	    26530,57,51,164,268,55,599,860,1192,842,3240,1170,1452,817,6142,
	    20935,33739,42347,9,36,133,240,221,661,183,1094,2157,2528,3432,
	    7009,9167,11635,12665,23268,15491,12,48,23,31,179,443,121,1290,30,
	    2260,2726,4273,7379,6071,5132,23268,15491,2,110,64,119,242,632,11,
	    632,959,3141,1098,4273,811,6071,5132,23268,15491,16,2,2,71,242,
	    251,11,341,3,2857,3371,2538,811,6071,5132,23268,15491,30,2,2,296,
	    2,603,793,785,717,1484,185,3976,6077,6071,5132,23268,15491,30,2,
	    106,130,2,663,998,393,1107,2113,4,4273,6205,1886,5132,23268,24490,
	    42,2,80,199,11,2,2,1499,2,2265,3143,2716,2505,1993,5132,20841,
	    5708,70,70,80,149,11,425,2,2,2,2,5055,2716,2896,634,4347,14733,
	    24490,86,70,126,149,11,425,110,798,2,2,2,6143,4055,836,1087,5916,
	    34535,2,48,16,149,394,603,110,808,836,2207,2,6143,4055,1993,2451,
	    4270,204,53,2,16,149,394,425,236,798,836,2207,2,91,4055,2095,2134,
	    13443,23709,53,2,16,149,439,425,110,918,1134,2207,2,107,900,142,
	    10539,13443,5474,30,70,16,31,394,525,236,393,836,542,2,2716,1333,
	    6542,3595,21793,14302,30,124,16,130,394,412,147,924,836,132,2,2,
	    1154,13195,3892,21793,38969,5,124,16,149,394,412,147,924,426,934,
	    334,2,2,4,6301,871,11298,42,70,107,149,394,412,110,2,898,378,1254,
	    2,2,4,3595,18819,2,42,48,80,79,439,412,190,2,898,378,4146,2,2,2,2,
	    2,22095,70,48,2,119,394,412,147,2,65,2099,617,2,2,2,2,2,7317,42,
	    48,2,119,394,82,147,1499,836,934,1879,2,2,2,2,2,2,53,48,2,31,394,
	    82,147,2,836,225,2,2,2,2,2,2,2,42,108,32,82,101,82,147,1016,836,
	    225,2,2,2,2,2,2,2,42,65,32,130,378,603,147,798,836,225,1146,2,2,2,
	    2,2,2,53,48,32,122,394,580,147,798,216,169,475,2,2,2,2,2,2,42,48,
	    31,122,394,580,236,798,104,378,4725,2,2,2,2,2,2,53,70,64,122,394,
	    444,110,808,300,2257,2,2,2,2,2,2,2,53,2,31,122,394,82,110,270,836,
	    2257,2,2,2,2,2,2,2,2,20,31,2,394,82,147,1344,1022,2257,475,2,2,2,
	    2,2,2,86,2,4,130,202,276,110,798,1022,2257,475,2,2,2,2,2,2,2,2,4,
	    130,279,601,110,798,1022,934,475,2,2,2,2,2,2,2,2,4,130,394,276,
	    632,798,1022,2576,475,2,2,2,2,2,2,2,2,126,130,279,276,147,798,
	    1420,934,475,2,2,2,2,2,2,2,2,16,2,2,276,147,798,1478,934,638,2,2,
	    2,2,2,2,2,2,16,2,2,276,148,798,1478,934,638,2,2,2,2,2,2,2,2,16,82,
	    2,112,2,798,1478,934,638,2,2,2,2,2,2,2,2,16,82,2,112,147,2,283,
	    934,2,2,2,2,2,2,2,2,2,16,2,2,112,147,2,2246,2257,3107,2,2,2,2,2,2 
	    };

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    doublereal d__1, d__2;

    /* Builtin functions */
    double d_mod(doublereal *, doublereal *), sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static doublereal alpha[40], x[40], value;
    static integer np;
    static doublereal vk[40], difint, finval;
    static integer lpsamp;
    static doublereal varprd;
    static integer sampls;
    static doublereal varest, varsqr;
    static integer intvls;
    extern /* Subroutine */ int krosum_(integer *, doublereal *, integer *, 
	    doublereal *, D_fp, doublereal *, doublereal *);


/*  Automatic Multidimensional Integration Subroutine */

/*         AUTHOR: Alan Genz */
/*                 Department of Mathematics */
/*                 Washington State University */
/*                 Pulman, WA 99164-3113 */

/*         Last Change: 5/15/93 */

/*  KROBOV computes an approximation to the integral */

/*      1  1     1 */
/*     I  I ... I       F(X)  dx(NDIM)...dx(2)dx(1) */
/*      0  0     0 */


/*  KROBOV uses randomized Korobov rules. The primary references are */
/*  "Randomization of Number Theoretic Methods for Multiple Integration" */
/*   R. Cranley and T.N.L. Patterson, SIAM J Numer Anal, 13, pp. 904-14, */
/*  and */
/*   "Optimal Parameters for Multidimensional Integration", */
/*    P. Keast, SIAM J Numer Anal, 10, pp.831-838. */

/* **************  Parameters for KROBOV  ******************************* */
/* ***** Input parameters */
/*  NDIM    Number of variables, must exceed 1, but not exceed 40 */
/*  MINVLS  Integer minimum number of function evaluations allowed. */
/*          MINVLS must not exceed MAXVLS.  If MINVLS < 0 then the */
/*          routine assumes a previous call of KROBOV has been made with */
/*          the same integrand and continues that calculation. */
/*  MAXVLS  Integer maximum number of function evaluations allowed. */
/*  FUNCTN  EXTERNALly declared user defined function to be integrated. */
/*          It must have parameters (NDIM,Z), where Z is a real array */
/*          of dimension NDIM. */
/*  ABSEPS  Required absolute accuracy. */
/*  RELEPS  Required relative accuracy. */
/* ***** Output parameters */
/*  MINVLS  Actual number of function evaluations used by KROBOV. */
/*  ABSERR  Estimated absolute accuracy of FINEST. */
/*  FINEST  Estimated value of integral. */
/*  IFAIL   IFAIL = 0 for normal exit, when */
/*                     ABSERR <= MAX(ABSEPS, RELEPS*ABS(FINEST)) */
/*                  and */
/*                     INTVLS <= MAXCLS. */
/*          IFAIL = 1 If MAXVLS was too small for KROBOV to obtain the */
/*                  required accuracy. In this case KROBOV returns a */
/*                  value FINEST with estimated absolute accuracy ABSERR. */
/* *********************************************************************** */
    *ifail = 1;
    intvls = 0;
    *finest = 0.;
    varest = 0.;
    if (*minvls >= 0) {
	*finest = 0.;
	sampls = 16;
	for (i__ = 1; i__ <= 17; ++i__) {
	    np = i__;
	    if (*minvls < sampls * p[i__ - 1]) {
		goto L10;
	    }
	}
/* Computing MAX */
	i__1 = 16, i__2 = *minvls / p[np - 1];
	sampls = max(i__1,i__2);
    }
L10:
    vk[0] = 1. / p[np - 1];
    i__1 = *ndim;
    for (i__ = 2; i__ <= i__1; ++i__) {
	d__1 = c__[np + (*ndim - 1) * 17 - 18] * vk[i__ - 2];
	vk[i__ - 1] = d_mod(&d__1, &c_b9);
    }
    finval = 0.;
    varsqr = 0.;
    lpsamp = sampls / 2;
    i__1 = lpsamp;
    for (i__ = 1; i__ <= i__1; ++i__) {
	krosum_(ndim, &value, &p[np - 1], vk, (D_fp)functn, alpha, x);
	difint = (value - finval) / i__;
	finval += difint;
/* Computing 2nd power */
	d__1 = difint;
	varsqr = (i__ - 2) * varsqr / i__ + d__1 * d__1;
    }
    intvls += (lpsamp << 1) * p[np - 1];
    varprd = varest * varsqr;
    *finest += (finval - *finest) / (varprd + 1);
    if (varsqr > 0.) {
	varest = (varprd + 1) / varsqr;
    }
    *abserr = sqrt(varsqr / (varprd + 1)) * 3;
/* Computing MAX */
    d__1 = *abseps, d__2 = abs(*finest) * *releps;
    if (*abserr > max(d__1,d__2)) {
	if (np < 17) {
	    ++np;
	} else {
/* Computing MAX */
/* Computing MIN */
	    i__3 = sampls * 3 / 2, i__4 = (*maxvls - intvls) / p[np - 1];
	    i__1 = 16, i__2 = min(i__3,i__4);
	    sampls = max(i__1,i__2);
	}
	if (intvls + sampls * p[np - 1] <= *maxvls) {
	    goto L10;
	}
    } else {
	*ifail = 0;
    }
    return 0;
} /* krobov_ */

/* Subroutine */ int krosum_(integer *ndim, doublereal *sumkro, integer *npts,
	 doublereal *vk, D_fp functn, doublereal *alpha, doublereal *x)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double d_mod(doublereal *, doublereal *);

    /* Local variables */
    static integer j, k;
    static doublereal sumfun;
    extern doublereal uni_(void);

    /* Parameter adjustments */
    --x;
    --alpha;
    --vk;

    /* Function Body */
    sumfun = 0.;
    i__1 = *ndim;
    for (j = 1; j <= i__1; ++j) {
	alpha[j] = uni_();
    }
    i__1 = *npts;
    for (k = 1; k <= i__1; ++k) {
	i__2 = *ndim;
	for (j = 1; j <= i__2; ++j) {
	    d__2 = alpha[j] + vk[j] * k;
	    x[j] = (d__1 = d_mod(&d__2, &c_b9) * 2 - 1, abs(d__1));
	}
	sumfun += (*functn)(ndim, &x[1]) / 2;
	i__2 = *ndim;
	for (j = 1; j <= i__2; ++j) {
	    x[j] = 1 - x[j];
	}
	sumfun += (*functn)(ndim, &x[1]) / 2;
    }
    *sumkro = sumfun / *npts;
    return 0;
} /* krosum_ */


/* Subroutine */ int sadmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__)
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal work[8000], d__, e;
    static integer m;
    extern /* Subroutine */ int adapt_(integer *, integer *, integer *, U_fp, 
	    doublereal *, doublereal *, integer *, doublereal *, doublereal *,
	     doublereal *, integer *);
    static integer infis;
    static doublereal oldval;
    static integer maxcls, newcls;
    extern /* Subroutine */ int fncmvt_();
    static integer rulcls, totcls;
    extern doublereal mvtnit_(integer *, integer *, doublereal *, doublereal *
	    , doublereal *, integer *, integer *, doublereal *, doublereal *);


/*     A subroutine for computing multivariate t probabilities. */
/*          Alan Genz */
/*          Department of Mathematics */
/*          Washington State University */
/*          Pullman, WA 99164-3113 */
/*          Email : AlanGenz@wsu.edu */

/*  Parameters */

/*     N      INTEGER, the number of variables. */
/*     NU     INTEGER, the number of degrees of freedom. */
/*     LOWER  REAL, array of lower integration limits. */
/*     UPPER  REAL, array of upper integration limits. */
/*     INFIN  INTEGER, array of integration limits flags: */
/*            if INFIN(I) < 0, Ith limits are (-infinity, infinity); */
/*            if INFIN(I) = 0, Ith limits are (-infinity, UPPER(I)]; */
/*            if INFIN(I) = 1, Ith limits are [LOWER(I), infinity); */
/*            if INFIN(I) = 2, Ith limits are [LOWER(I), UPPER(I)]. */
/*     CORREL REAL, array of correlation coefficients; the correlation */
/*            coefficient in row I column J of the correlation matrix */
/*            should be stored in CORREL( J + ((I-2)*(I-1))/2 ), for J < I. */
/*     MAXPTS INTEGER, maximum number of function values allowed. This */
/*            parameter can be used to limit the time taken. A sensible */
/*            strategy is to start with MAXPTS = 1000*N, and then */
/*            increase MAXPTS if ERROR is too large. */
/*     ABSEPS REAL absolute error tolerance. */
/*     RELEPS REAL relative error tolerance. */
/*     ERROR  REAL, estimated absolute error, with 99% confidence level. */
/*     VALUE  REAL, estimated value for the integral */
/*     INFORM INTEGER, termination status parameter: */
/*            if INFORM = 0, normal completion with ERROR < EPS; */
/*            if INFORM = 1, completion with ERROR > EPS and MAXPTS */
/*                           function vaules used; increase MAXPTS to */
/*                           decrease ERROR; */
/*            if INFORM = 2, N > 20 or N < 1. */

    /* Parameter adjustments */
    --correl;
    --infin;
    --upper;
    --lower;

    /* Function Body */
    if (*n > 20 || *n < 1) {
	*inform__ = 2;
	*value = 0.;
	*error = 1.;
	return 0;
    }
    *inform__ = (integer) mvtnit_(n, nu, &correl[1], &lower[1], &upper[1], &
	    infin[1], &infis, &d__, &e);
    m = *n - infis;
    if (m == 0) {
	*value = 1.;
	*error = 0.;
    } else if (m == 1) {
	*value = e - d__;
	*error = 2e-16f;
    } else {

/*        Call the subregion adaptive integration subroutine */

	--m;
	rulcls = 1;
	adapt_(&m, &rulcls, &c__0, (U_fp)fncmvt_, abseps, releps, &c__8000, 
		work, error, value, inform__);
/* Computing MIN */
	i__1 = rulcls * 10;
	maxcls = min(i__1,*maxpts);
	totcls = 0;
	adapt_(&m, &totcls, &maxcls, (U_fp)fncmvt_, abseps, releps, &c__8000, 
		work, error, value, inform__);
/* Computing MAX */
	d__1 = *abseps, d__2 = *releps * abs(*value);
	if (*error > max(d__1,d__2)) {
L10:
	    oldval = *value;
/* Computing MAX */
/* Computing MIN */
	    i__3 = maxcls * 3 / 2, i__4 = *maxpts - totcls;
	    i__1 = rulcls << 1, i__2 = min(i__3,i__4);
	    maxcls = max(i__1,i__2);
	    newcls = -1;
	    adapt_(&m, &newcls, &maxcls, (U_fp)fncmvt_, abseps, releps, &
		    c__8000, work, error, value, inform__);
	    totcls += newcls;
/* Computing 2nd power */
	    d__2 = *error;
	    *error = (d__1 = *value - oldval, abs(d__1)) + sqrt(rulcls * (
		    d__2 * d__2) / totcls);
/* Computing MAX */
	    d__1 = *abseps, d__2 = *releps * abs(*value);
	    if (*error > max(d__1,d__2)) {
		if (*maxpts - totcls > rulcls << 1) {
		    goto L10;
		}
	    } else {
		*inform__ = 0;
	    }
	}
    }
    return 0;
} /* sadmvt_ */


/* Subroutine */ int adapt_(integer *ndim, integer *mincls, integer *maxcls, 
	D_fp functn, doublereal *absreq, doublereal *relreq, integer *lenwrk, 
	doublereal *work, doublereal *absest, doublereal *finest, integer *
	inform__)
{
    /* Builtin functions */
    integer pow_ii(integer *, integer *);

    /* Local variables */
    extern /* Subroutine */ int adbase_(integer *, integer *, integer *, D_fp,
	     doublereal *, doublereal *, doublereal *, doublereal *, integer *
	    , integer *, integer *, integer *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, integer *);
    static integer inmesh, invals, sbrgns, inwdth, lenrul, inerrs, rulcls, 
	    inmshs, inwork, inlowr, inpnts, inwgts, inuppr, mxrgns, inptrs, 
	    inlwrs, inuprs;


/*   Adaptive Multidimensional Integration Subroutine */

/*   Author: Alan Genz */
/*           Department of Mathematics */
/*           Washington State University */
/*           Pullman, WA 99164-3113 USA */

/*  This subroutine computes an approximation to the integral */

/*      1 1     1 */
/*     I I ... I       FUNCTN(NDIM,X)  dx(NDIM)...dx(2)dx(1) */
/*      0 0     0 */

/* **************  Parameters for ADAPT  ******************************** */

/* ***** Input Parameters */

/*  NDIM    Integer number of integration variables. */
/*  MINCLS  Integer minimum number of FUNCTN calls to be allowed; MINCLS */
/*          must not exceed MAXCLS. If MINCLS < 0, then ADAPT assumes */
/*          that a previous call of ADAPT has been made with the same */
/*          integrand and continues that calculation. */
/*  MAXCLS  Integer maximum number of FUNCTN calls to be used; MAXCLS */
/*          must be >= RULCLS, the number of function calls required for */
/*          one application of the basic integration rule. */
/*           IF ( NDIM .EQ. 1 ) THEN */
/*              RULCLS = 11 */
/*           ELSE IF ( NDIM .LT. 15 ) THEN */
/*              RULCLS = 2**NDIM + 2*NDIM*(NDIM+3) + 1 */
/*           ELSE */
/*              RULCLS = 1 + NDIM*(24-NDIM*(6-NDIM*4))/3 */
/*           ENDIF */
/*  FUNCTN  Externally declared real user defined integrand. Its */
/*          parameters must be (NDIM, Z), where Z is a real array of */
/*          length NDIM. */
/*  ABSREQ  Real required absolute accuracy. */
/*  RELREQ  Real required relative accuracy. */
/*  LENWRK  Integer length of real array WORK (working storage); ADAPT */
/*          needs LENWRK >= 16*NDIM + 27. For maximum efficiency LENWRK */
/*          should be about 2*NDIM*MAXCLS/RULCLS if MAXCLS FUNCTN */
/*          calls are needed. If LENWRK is significantly less than this, */
/*          ADAPT may be less efficient. */

/* ***** Output Parameters */

/*  MINCLS  Actual number of FUNCTN calls used by ADAPT. */
/*  WORK    Real array (length LENWRK) of working storage. This contains */
/*          information that is needed for additional calls of ADAPT */
/*          using the same integrand (input MINCLS < 0). */
/*  ABSEST  Real estimated absolute accuracy. */
/*  FINEST  Real estimated value of integral. */
/*  INFORM  INFORM = 0 for normal exit, when ABSEST <= ABSREQ or */
/*                     ABSEST <= |FINEST|*RELREQ with MINCLS <= MAXCLS. */
/*          INFORM = 1 if MAXCLS was too small for ADAPT to obtain the */
/*                     result FINEST to within the requested accuracy. */
/*          INFORM = 2 if MINCLS > MAXCLS, LENWRK < 16*NDIM + 27 or */
/*                     RULCLS > MAXCLS. */

/* *********************************************************************** */

/*     Begin driver routine. This routine partitions the working storage */
/*      array and then calls the main subroutine ADBASE. */

    /* Parameter adjustments */
    --work;

    /* Function Body */
    if (*ndim == 1) {
	lenrul = 5;
	rulcls = 9;
    } else if (*ndim < 12) {
	lenrul = 6;
	rulcls = pow_ii(&c__2, ndim) + (*ndim << 1) * (*ndim + 2) + 1;
    } else {
	lenrul = 6;
	rulcls = (*ndim << 1) * ((*ndim << 1) + 1) + 1;
    }
    if (*lenwrk >= lenrul * (*ndim + 4) + *ndim * 10 + 3 && rulcls <= *maxcls 
	    && *mincls <= *maxcls) {
	mxrgns = (*lenwrk - lenrul * (*ndim + 4) - *ndim * 7) / (*ndim * 3 + 
		3);
	inerrs = 1;
	invals = inerrs + mxrgns;
	inptrs = invals + mxrgns;
	inlwrs = inptrs + mxrgns;
	inuprs = inlwrs + mxrgns * *ndim;
	inmshs = inuprs + mxrgns * *ndim;
	inwgts = inmshs + mxrgns * *ndim;
	inpnts = inwgts + (lenrul << 2);
	inlowr = inpnts + lenrul * *ndim;
	inuppr = inlowr + *ndim;
	inwdth = inuppr + *ndim;
	inmesh = inwdth + *ndim;
	inwork = inmesh + *ndim;
	if (*mincls < 0) {
	    sbrgns = (integer) work[*lenwrk];
	}
	adbase_(ndim, mincls, maxcls, (D_fp)functn, absreq, relreq, absest, 
		finest, &sbrgns, &mxrgns, &rulcls, &lenrul, &work[inerrs], &
		work[invals], &work[inptrs], &work[inlwrs], &work[inuprs], &
		work[inmshs], &work[inwgts], &work[inpnts], &work[inlowr], &
		work[inuppr], &work[inwdth], &work[inmesh], &work[inwork], 
		inform__);
	work[*lenwrk] = (doublereal) sbrgns;
    } else {
	*inform__ = 2;
	*mincls = rulcls;
    }
    return 0;
} /* adapt_ */

/* Subroutine */ int bsinit_(integer *ndim, doublereal *w, integer *lenrul, 
	doublereal *g)
{
    /* System generated locals */
    integer w_dim1, w_offset, g_dim1, g_offset, i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    integer pow_ii(integer *, integer *);
    double sqrt(doublereal);

    /* Local variables */
    static doublereal lamp;
    static integer i__, j;
    static doublereal rulcon;
    extern /* Subroutine */ int rulnrm_(integer *, integer *, integer *, 
	    doublereal *, doublereal *);
    static integer rulpts[6];
    static doublereal lam1, lam2, lam3;


/*     For initializing basic rule weights and symmetric sum parameters. */


/*     The following code determines rule parameters and weights for a */
/*      degree 7 rule (W(1,1),...,W(5,1)), two degree 5 comparison rules */
/*      (W(1,2),...,W(5,2) and W(1,3),...,W(5,3)) and a degree 3 */
/*      comparison rule (W(1,4),...W(5,4)). */

/*       If NDIM = 1, then LENRUL = 5 and total points = 9. */
/*       If NDIM < SDIM, then LENRUL = 6 and */
/*                      total points = 1+2*NDIM*(NDIM+2)+2**NDIM. */
/*       If NDIM > = SDIM, then LENRUL = 6 and */
/*                      total points = 1+2*NDIM*(1+2*NDIM). */

    /* Parameter adjustments */
    g_dim1 = *ndim;
    g_offset = g_dim1 + 1;
    g -= g_offset;
    w_dim1 = *lenrul;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    i__1 = *lenrul;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *ndim;
	for (j = 1; j <= i__2; ++j) {
	    g[j + i__ * g_dim1] = 0.;
	}
	for (j = 1; j <= 4; ++j) {
	    w[i__ + j * w_dim1] = 0.;
	}
    }
    rulpts[4] = (*ndim << 1) * (*ndim - 1);
    rulpts[3] = *ndim << 1;
    rulpts[2] = *ndim << 1;
    rulpts[1] = *ndim << 1;
    rulpts[0] = 1;
    lamp = .85f;
    lam3 = .4707f;
    lam2 = 4 / (15 - 5 / lam3);
/* Computing 2nd power */
    d__1 = lam2;
    w[w_dim1 + 5] = (3 - lam3 * 5) / ((lam2 - lam3) * 180 * (d__1 * d__1));
    if (*ndim < 12) {
	lam1 = lam3 * 8 * (lam3 * 31 - 15) / ((lam3 * 3 - 1) * (lam3 * 5 - 3) 
		* 35);
/* Computing 3rd power */
	d__1 = lam3 * 3;
	w[*lenrul + w_dim1] = 1 / (d__1 * (d__1 * d__1)) / pow_ii(&c__2, ndim)
		;
    } else {
	lam1 = (lam3 * (15 - lam2 * 21) + (*ndim - 1) * 35 * (lam2 - lam3) / 
		9) / (lam3 * (21 - lam2 * 35) + (*ndim - 1) * 35 * (lam2 / 
		lam3 - 1) / 9);
/* Computing 3rd power */
	d__1 = lam3 * 3;
	w[w_dim1 + 6] = 1 / (d__1 * (d__1 * d__1) * 4);
    }
    w[w_dim1 + 3] = (15 - (lam3 + lam1) * 21 + lam3 * 35 * lam1) / (lam2 * 
	    210 * (lam2 - lam3) * (lam2 - lam1)) - (*ndim - 1 << 1) * w[
	    w_dim1 + 5];
    w[w_dim1 + 2] = (15 - (lam3 + lam2) * 21 + lam3 * 35 * lam2) / (lam1 * 
	    210 * (lam1 - lam3) * (lam1 - lam2));
    if (*ndim < 12) {
	rulpts[*lenrul - 1] = pow_ii(&c__2, ndim);
	lam3 = sqrt(lam3);
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    g[i__ + *lenrul * g_dim1] = lam3;
	}
    } else {
/* Computing 3rd power */
	d__1 = lam3 * 3;
	w[w_dim1 + 6] = 1 / (d__1 * (d__1 * d__1) * 4);
	rulpts[5] = (*ndim << 1) * (*ndim - 1);
	lam3 = sqrt(lam3);
	for (i__ = 1; i__ <= 2; ++i__) {
	    g[i__ + g_dim1 * 6] = lam3;
	}
    }
    if (*ndim > 1) {
/* Computing 2nd power */
	d__1 = lam2 * 6;
	w[(w_dim1 << 1) + 5] = 1 / (d__1 * d__1);
/* Computing 2nd power */
	d__1 = lam2 * 6;
	w[w_dim1 * 3 + 5] = 1 / (d__1 * d__1);
    }
    w[(w_dim1 << 1) + 3] = (3 - lam1 * 5) / (lam2 * 30 * (lam2 - lam1)) - (*
	    ndim - 1 << 1) * w[(w_dim1 << 1) + 5];
    w[(w_dim1 << 1) + 2] = (3 - lam2 * 5) / (lam1 * 30 * (lam1 - lam2));
    w[w_dim1 * 3 + 4] = (3 - lam2 * 5) / (lamp * 30 * (lamp - lam2));
    w[w_dim1 * 3 + 3] = (3 - lamp * 5) / (lam2 * 30 * (lam2 - lamp)) - (*ndim 
	    - 1 << 1) * w[w_dim1 * 3 + 5];
    w[(w_dim1 << 2) + 2] = 1 / (lam1 * 6);
    lamp = sqrt(lamp);
    lam2 = sqrt(lam2);
    lam1 = sqrt(lam1);
    g[(g_dim1 << 1) + 1] = lam1;
    g[g_dim1 * 3 + 1] = lam2;
    g[(g_dim1 << 2) + 1] = lamp;
    if (*ndim > 1) {
	g[g_dim1 * 5 + 1] = lam2;
	g[g_dim1 * 5 + 2] = lam2;
    }
    for (j = 1; j <= 4; ++j) {
	w[j * w_dim1 + 1] = 1.;
	i__1 = *lenrul;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    w[j * w_dim1 + 1] -= rulpts[i__ - 1] * w[i__ + j * w_dim1];
	}
    }
    rulcon = 2.;
    rulnrm_(lenrul, &c__4, rulpts, &w[w_offset], &rulcon);
    return 0;
} /* bsinit_ */

/* Subroutine */ int rulnrm_(integer *lenrul, integer *numnul, integer *
	rulpts, doublereal *w, doublereal *rulcon)
{
    /* System generated locals */
    integer w_dim1, w_offset, i__1, i__2, i__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j, k;
    static doublereal alpha, normcf, normnl;


/*     Compute orthonormalized null rules. */

    /* Parameter adjustments */
    w_dim1 = *lenrul;
    w_offset = w_dim1 + 1;
    w -= w_offset;
    --rulpts;

    /* Function Body */
    normcf = 0.;
    i__1 = *lenrul;
    for (i__ = 1; i__ <= i__1; ++i__) {
	normcf += rulpts[i__] * w[i__ + w_dim1] * w[i__ + w_dim1];
    }
    i__1 = *numnul;
    for (k = 2; k <= i__1; ++k) {
	i__2 = *lenrul;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    w[i__ + k * w_dim1] -= w[i__ + w_dim1];
	}
	i__2 = k - 1;
	for (j = 2; j <= i__2; ++j) {
	    alpha = 0.;
	    i__3 = *lenrul;
	    for (i__ = 1; i__ <= i__3; ++i__) {
		alpha += rulpts[i__] * w[i__ + j * w_dim1] * w[i__ + k * 
			w_dim1];
	    }
	    alpha = -alpha / normcf;
	    i__3 = *lenrul;
	    for (i__ = 1; i__ <= i__3; ++i__) {
		w[i__ + k * w_dim1] += alpha * w[i__ + j * w_dim1];
	    }
	}
	normnl = 0.;
	i__2 = *lenrul;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    normnl += rulpts[i__] * w[i__ + k * w_dim1] * w[i__ + k * w_dim1];
	}
	alpha = sqrt(normcf / normnl);
	i__2 = *lenrul;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    w[i__ + k * w_dim1] = alpha * w[i__ + k * w_dim1];
	}
    }
    i__1 = *numnul;
    for (j = 2; j <= i__1; ++j) {
	i__2 = *lenrul;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    w[i__ + j * w_dim1] /= *rulcon;
	}
    }
    return 0;
} /* rulnrm_ */

/* Subroutine */ int adbase_(integer *ndim, integer *mincls, integer *maxcls, 
	D_fp functn, doublereal *absreq, doublereal *relreq, doublereal *
	absest, doublereal *finest, integer *sbrgns, integer *mxrgns, integer 
	*rulcls, integer *lenrul, doublereal *errors, doublereal *values, 
	doublereal *pontrs, doublereal *lowers, doublereal *uppers, 
	doublereal *meshes, doublereal *weghts, doublereal *points, 
	doublereal *lower, doublereal *upper, doublereal *width, doublereal *
	mesh, doublereal *work, integer *inform__)
{
    /* System generated locals */
    integer lowers_dim1, lowers_offset, uppers_dim1, uppers_offset, 
	    meshes_dim1, meshes_offset, i__1, i__2;
    doublereal d__1, d__2;

    /* Local variables */
    static integer i__, j;
    extern /* Subroutine */ int differ_(integer *, doublereal *, doublereal *,
	     doublereal *, doublereal *, doublereal *, D_fp, integer *, 
	    integer *);
    static integer difcls, divaxn, rgncls, funcls;
    extern /* Subroutine */ int bsinit_(integer *, doublereal *, integer *, 
	    doublereal *), basrul_(integer *, doublereal *, doublereal *, 
	    doublereal *, D_fp, doublereal *, integer *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
    static integer nwrgns;
    extern /* Subroutine */ int trestr_(integer *, integer *, doublereal *, 
	    doublereal *);
    static integer top;


/*        Main adaptive integration subroutine */


/*     Initialization of subroutine */

    /* Parameter adjustments */
    meshes_dim1 = *ndim;
    meshes_offset = meshes_dim1 + 1;
    meshes -= meshes_offset;
    uppers_dim1 = *ndim;
    uppers_offset = uppers_dim1 + 1;
    uppers -= uppers_offset;
    lowers_dim1 = *ndim;
    lowers_offset = lowers_dim1 + 1;
    lowers -= lowers_offset;
    --errors;
    --values;
    --pontrs;
    --weghts;
    --points;
    --lower;
    --upper;
    --width;
    --mesh;
    --work;

    /* Function Body */
    *inform__ = 2;
    funcls = 0;
    bsinit_(ndim, &weghts[1], lenrul, &points[1]);
    if (*mincls >= 0) {

/*       When MINCLS >= 0 determine initial subdivision of the */
/*       integration region and apply basic rule to each subregion. */

	*sbrgns = 0;
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    lower[i__] = 0.;
	    mesh[i__] = 1.;
	    width[i__] = 1 / (mesh[i__] * 2);
	    upper[i__] = 1.;
	}
	divaxn = 0;
	rgncls = *rulcls;
	nwrgns = 1;
L10:
	differ_(ndim, &lower[1], &upper[1], &width[1], &work[1], &work[*ndim 
		+ 1], (D_fp)functn, &divaxn, &difcls);
	funcls += difcls;
	if (funcls + rgncls * (mesh[divaxn] + 1) / mesh[divaxn] <= (
		doublereal) (*mincls)) {
	    rgncls = (integer) (rgncls * (mesh[divaxn] + 1) / mesh[divaxn]);
	    nwrgns = (integer) (nwrgns * (mesh[divaxn] + 1) / mesh[divaxn]);
	    ++mesh[divaxn];
	    width[divaxn] = 1 / (mesh[divaxn] * 2);
	    goto L10;
	}
	if (nwrgns <= *mxrgns) {
	    i__1 = *ndim;
	    for (i__ = 1; i__ <= i__1; ++i__) {
		upper[i__] = lower[i__] + width[i__] * 2;
		mesh[i__] = 1.;
	    }
	}

/*     Apply basic rule to subregions and store results in heap. */

L20:
	++(*sbrgns);
	basrul_(ndim, &lower[1], &upper[1], &width[1], (D_fp)functn, &weghts[
		1], lenrul, &points[1], &work[1], &work[*ndim + 1], &errors[*
		sbrgns], &values[*sbrgns]);
	trestr_(sbrgns, sbrgns, &pontrs[1], &errors[1]);
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    lowers[i__ + *sbrgns * lowers_dim1] = lower[i__];
	    uppers[i__ + *sbrgns * uppers_dim1] = upper[i__];
	    meshes[i__ + *sbrgns * meshes_dim1] = mesh[i__];
	}
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    lower[i__] = upper[i__];
	    upper[i__] = lower[i__] + width[i__] * 2;
	    if (lower[i__] + width[i__] < 1.) {
		goto L20;
	    }
	    lower[i__] = 0.;
	    upper[i__] = lower[i__] + width[i__] * 2;
	}
	funcls += *sbrgns * *rulcls;
    }

/*     Check for termination */

L30:
    *finest = 0.;
    *absest = 0.;
    i__1 = *sbrgns;
    for (i__ = 1; i__ <= i__1; ++i__) {
	*finest += values[i__];
	*absest += errors[i__];
    }
/* Computing MAX */
    d__1 = *absreq, d__2 = *relreq * abs(*finest);
    if (*absest > max(d__1,d__2) || funcls < *mincls) {

/*     Prepare to apply basic rule in (parts of) subregion with */
/*     largest error. */

	top = (integer) pontrs[1];
	rgncls = *rulcls;
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    lower[i__] = lowers[i__ + top * lowers_dim1];
	    upper[i__] = uppers[i__ + top * uppers_dim1];
	    mesh[i__] = meshes[i__ + top * meshes_dim1];
	    width[i__] = (upper[i__] - lower[i__]) / (mesh[i__] * 2);
	    rgncls = (integer) (rgncls * mesh[i__]);
	}
	differ_(ndim, &lower[1], &upper[1], &width[1], &work[1], &work[*ndim 
		+ 1], (D_fp)functn, &divaxn, &difcls);
	funcls += difcls;
	rgncls = (integer) (rgncls * (mesh[divaxn] + 1) / mesh[divaxn]);
	if (funcls + rgncls <= *maxcls) {
	    if (*sbrgns + 1 <= *mxrgns) {

/*     Prepare to subdivide into two pieces. */

		nwrgns = 1;
		width[divaxn] /= 2;
	    } else {
		nwrgns = 0;
		width[divaxn] = width[divaxn] * mesh[divaxn] / (mesh[divaxn] 
			+ 1);
		meshes[divaxn + top * meshes_dim1] = mesh[divaxn] + 1;
	    }
	    if (nwrgns > 0) {

/*     Only allow local subdivision when space is available. */

		i__1 = *sbrgns + nwrgns;
		for (j = *sbrgns + 1; j <= i__1; ++j) {
		    i__2 = *ndim;
		    for (i__ = 1; i__ <= i__2; ++i__) {
			lowers[i__ + j * lowers_dim1] = lower[i__];
			uppers[i__ + j * uppers_dim1] = upper[i__];
			meshes[i__ + j * meshes_dim1] = mesh[i__];
		    }
		}
		uppers[divaxn + top * uppers_dim1] = lower[divaxn] + width[
			divaxn] * 2;
		lowers[divaxn + (*sbrgns + 1) * lowers_dim1] = uppers[divaxn 
			+ top * uppers_dim1];
	    }
	    funcls += rgncls;
	    basrul_(ndim, &lowers[top * lowers_dim1 + 1], &uppers[top * 
		    uppers_dim1 + 1], &width[1], (D_fp)functn, &weghts[1], 
		    lenrul, &points[1], &work[1], &work[*ndim + 1], &errors[
		    top], &values[top]);
	    trestr_(&top, sbrgns, &pontrs[1], &errors[1]);
	    i__1 = *sbrgns + nwrgns;
	    for (i__ = *sbrgns + 1; i__ <= i__1; ++i__) {

/*     Apply basic rule and store results in heap. */

		basrul_(ndim, &lowers[i__ * lowers_dim1 + 1], &uppers[i__ * 
			uppers_dim1 + 1], &width[1], (D_fp)functn, &weghts[1],
			 lenrul, &points[1], &work[1], &work[*ndim + 1], &
			errors[i__], &values[i__]);
		trestr_(&i__, &i__, &pontrs[1], &errors[1]);
	    }
	    *sbrgns += nwrgns;
	    goto L30;
	} else {
	    *inform__ = 1;
	}
    } else {
	*inform__ = 0;
    }
    *mincls = funcls;
    return 0;
} /* adbase_ */

/* Subroutine */ int basrul_(integer *ndim, doublereal *a, doublereal *b, 
	doublereal *width, D_fp functn, doublereal *w, integer *lenrul, 
	doublereal *g, doublereal *center, doublereal *z__, doublereal *
	rgnert, doublereal *basest)
{
    /* System generated locals */
    integer w_dim1, w_offset, g_dim1, g_offset, i__1;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static doublereal rgncmp, rgnval, rgncpt, rgnerr, rgnvol;
    extern doublereal fulsum_(integer *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, D_fp);
    static doublereal fsymsm;


/*     For application of basic integration rule */


/*     Compute Volume and Center of Subregion */

    /* Parameter adjustments */
    --z__;
    --center;
    --width;
    --b;
    --a;
    g_dim1 = *ndim;
    g_offset = g_dim1 + 1;
    g -= g_offset;
    w_dim1 = *lenrul;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    rgnvol = 1.;
    i__1 = *ndim;
    for (i__ = 1; i__ <= i__1; ++i__) {
	rgnvol = rgnvol * 2 * width[i__];
	center[i__] = a[i__] + width[i__];
    }
    *basest = 0.;
    *rgnert = 0.;

/*     Compute basic rule and error */

L10:
    rgnval = 0.;
    rgnerr = 0.;
    rgncmp = 0.;
    rgncpt = 0.;
    i__1 = *lenrul;
    for (i__ = 1; i__ <= i__1; ++i__) {
	fsymsm = fulsum_(ndim, &center[1], &width[1], &z__[1], &g[i__ * 
		g_dim1 + 1], (D_fp)functn);
/*     Basic Rule */
	rgnval += w[i__ + w_dim1] * fsymsm;
/*     First comparison rule */
	rgnerr += w[i__ + (w_dim1 << 1)] * fsymsm;
/*     Second comparison rule */
	rgncmp += w[i__ + w_dim1 * 3] * fsymsm;
/*     Third Comparison rule */
	rgncpt += w[i__ + (w_dim1 << 2)] * fsymsm;
    }

/*     Error estimation */

/* Computing 2nd power */
    d__1 = rgncmp;
/* Computing 2nd power */
    d__2 = rgnerr;
    rgnerr = sqrt(d__1 * d__1 + d__2 * d__2);
/* Computing 2nd power */
    d__1 = rgncpt;
/* Computing 2nd power */
    d__2 = rgncmp;
    rgncmp = sqrt(d__1 * d__1 + d__2 * d__2);
    if (rgnerr * 4 < rgncmp) {
	rgnerr /= 2;
    }
    if (rgnerr * 2 > rgncmp) {
	rgnerr = max(rgnerr,rgncmp);
    }
    *rgnert += rgnvol * rgnerr;
    *basest += rgnvol * rgnval;

/*     When subregion has more than one piece, determine next piece and */
/*      loop back to apply basic rule. */

    i__1 = *ndim;
    for (i__ = 1; i__ <= i__1; ++i__) {
	center[i__] += width[i__] * 2;
	if (center[i__] < b[i__]) {
	    goto L10;
	}
	center[i__] = a[i__] + width[i__];
    }
    return 0;
} /* basrul_ */

doublereal fulsum_(integer *s, doublereal *center, doublereal *hwidth, 
	doublereal *x, doublereal *g, D_fp f)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal ret_val;

    /* Local variables */
    static integer i__, l;
    static doublereal gi, gl;
    static integer ixchng, lxchng;
    static doublereal intsum;


/* ***  To compute fully symmetric basic rule sum */

    /* Parameter adjustments */
    --g;
    --x;
    --hwidth;
    --center;

    /* Function Body */
    ret_val = 0.;

/*     Compute centrally symmetric sum for permutation of G */

L10:
    intsum = 0.;
    i__1 = *s;
    for (i__ = 1; i__ <= i__1; ++i__) {
	x[i__] = center[i__] + g[i__] * hwidth[i__];
    }
L20:
    intsum += (*f)(s, &x[1]);
    i__1 = *s;
    for (i__ = 1; i__ <= i__1; ++i__) {
	g[i__] = -g[i__];
	x[i__] = center[i__] + g[i__] * hwidth[i__];
	if (g[i__] < 0.) {
	    goto L20;
	}
    }
    ret_val += intsum;

/*     Find next distinct permuation of G and loop back for next sum */

    i__1 = *s;
    for (i__ = 2; i__ <= i__1; ++i__) {
	if (g[i__ - 1] > g[i__]) {
	    gi = g[i__];
	    ixchng = i__ - 1;
	    i__2 = (i__ - 1) / 2;
	    for (l = 1; l <= i__2; ++l) {
		gl = g[l];
		g[l] = g[i__ - l];
		g[i__ - l] = gl;
		if (gl <= gi) {
		    --ixchng;
		}
		if (g[l] > gi) {
		    lxchng = l;
		}
	    }
	    if (g[ixchng] <= gi) {
		ixchng = lxchng;
	    }
	    g[i__] = g[ixchng];
	    g[ixchng] = gi;
	    goto L10;
	}
    }

/*     End loop for permutations of G and associated sums */

/*     Restore original order to G's */

    i__1 = *s / 2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	gi = g[i__];
	g[i__] = g[*s + 1 - i__];
	g[*s + 1 - i__] = gi;
    }
    return ret_val;
} /* fulsum_ */

/* Subroutine */ int differ_(integer *ndim, doublereal *a, doublereal *b, 
	doublereal *width, doublereal *z__, doublereal *dif, D_fp functn, 
	integer *divaxn, integer *difcls)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__;
    static doublereal frthdf, funcen, widthi;


/*     Compute fourth differences and subdivision axes */

    /* Parameter adjustments */
    --dif;
    --z__;
    --width;
    --b;
    --a;

    /* Function Body */
    *difcls = 0;
    *divaxn = *divaxn % *ndim + 1;
    if (*ndim > 1) {
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    dif[i__] = 0.;
	    z__[i__] = a[i__] + width[i__];
	}
L10:
	funcen = (*functn)(ndim, &z__[1]);
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    widthi = width[i__] / 5;
	    frthdf = funcen * 6;
	    z__[i__] -= widthi * 4;
	    frthdf += (*functn)(ndim, &z__[1]);
	    z__[i__] += widthi * 2;
	    frthdf -= (*functn)(ndim, &z__[1]) * 4;
	    z__[i__] += widthi * 4;
	    frthdf -= (*functn)(ndim, &z__[1]) * 4;
	    z__[i__] += widthi * 2;
	    frthdf += (*functn)(ndim, &z__[1]);
/*     Do not include differences below roundoff */
	    if (funcen + frthdf / 8 != funcen) {
		dif[i__] += abs(frthdf) * width[i__];
	    }
	    z__[i__] -= widthi * 4;
	}
	*difcls = *difcls + (*ndim << 2) + 1;
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    z__[i__] += width[i__] * 2;
	    if (z__[i__] < b[i__]) {
		goto L10;
	    }
	    z__[i__] = a[i__] + width[i__];
	}
	i__1 = *ndim;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    if (dif[*divaxn] < dif[i__]) {
		*divaxn = i__;
	    }
	}
    }
    return 0;
} /* differ_ */

/* Subroutine */ int trestr_(integer *pointr, integer *sbrgns, doublereal *
	pontrs, doublereal *rgners)
{
    static doublereal rgnerr;
    static integer subrgn, subtmp;

/* ***BEGIN PROLOGUE TRESTR */
/* ***PURPOSE TRESTR maintains a heap for subregions. */
/* ***DESCRIPTION TRESTR maintains a heap for subregions. */
/*            The subregions are ordered according to the size of the */
/*            greatest error estimates of each subregion (RGNERS). */

/*   PARAMETERS */

/*     POINTR Integer. */
/*            The index for the subregion to be inserted in the heap. */
/*     SBRGNS Integer. */
/*            Number of subregions in the heap. */
/*     PONTRS Real array of dimension SBRGNS. */
/*            Used to store the indices for the greatest estimated errors */
/*            for each subregion. */
/*     RGNERS Real array of dimension SBRGNS. */
/*            Used to store the greatest estimated errors for each */
/*            subregion. */

/* ***ROUTINES CALLED NONE */
/* ***END PROLOGUE TRESTR */

/*   Global variables. */


/*   Local variables. */

/*   RGNERR Intermediate storage for the greatest error of a subregion. */
/*   SUBRGN Position of child/parent subregion in the heap. */
/*   SUBTMP Position of parent/child subregion in the heap. */


/* ***FIRST PROCESSING STATEMENT TRESTR */

    /* Parameter adjustments */
    --rgners;
    --pontrs;

    /* Function Body */
    rgnerr = rgners[*pointr];
    if ((doublereal) (*pointr) == pontrs[1]) {

/*        Move the new subregion inserted at the top of the heap */
/*        to its correct position in the heap. */

	subrgn = 1;
L10:
	subtmp = subrgn << 1;
	if (subtmp <= *sbrgns) {
	    if (subtmp != *sbrgns) {

/*              Find maximum of left and right child. */

		if (rgners[(integer) pontrs[subtmp]] < rgners[(integer) 
			pontrs[subtmp + 1]]) {
		    ++subtmp;
		}
	    }

/*           Compare maximum child with parent. */
/*           If parent is maximum, then done. */

	    if (rgnerr < rgners[(integer) pontrs[subtmp]]) {

/*              Move the pointer at position subtmp up the heap. */

		pontrs[subrgn] = pontrs[subtmp];
		subrgn = subtmp;
		goto L10;
	    }
	}
    } else {

/*        Insert new subregion in the heap. */

	subrgn = *sbrgns;
L20:
	subtmp = subrgn / 2;
	if (subtmp >= 1) {

/*           Compare child with parent. If parent is maximum, then done. */

	    if (rgnerr > rgners[(integer) pontrs[subtmp]]) {

/*              Move the pointer at position subtmp down the heap. */

		pontrs[subrgn] = pontrs[subtmp];
		subrgn = subtmp;
		goto L20;
	    }
	}
    }
    pontrs[subrgn] = (doublereal) (*pointr);

/* ***END TRESTR */

    return 0;
} /* trestr_ */


/* Subroutine */ int sphmvt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, integer *infin, doublereal *correl, integer *
	maxpts, doublereal *abseps, doublereal *releps, doublereal *error, 
	doublereal *value, integer *inform__)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1, d__2;

    /* Local variables */
    static integer ivls;
    static doublereal d__, e;
    static integer infis, ns;
    extern /* Subroutine */ int tcrude_(integer *, integer *, doublereal *, 
	    doublereal *, integer *);
    extern doublereal spmvti_(integer *, integer *, doublereal *, doublereal *
	    , doublereal *, integer *, integer *, doublereal *, doublereal *, 
	    integer *);
    static doublereal eps;
    static integer mpt;


/*     A subroutine for computing multivariate t probabilities. */
/*     This subroutine uses a modified version of the Mont-Carlo */
/*     algorithm for multivariatie Normal probabilities in the paper */
/*       "Three Digit Accurate Multiple Normal Probabilities", */
/*          pp. 369-380, Numer. Math. 35(1980), by I. Deak */


/*  Parameters */

/*     N      INTEGER, the number of variables. */
/*     NU     INTEGER, the number of degrees of freedom. */
/*     LOWER  REAL, array of lower integration limits. */
/*     UPPER  REAL, array of upper integration limits. */
/*     INFIN  INTEGER, array of integration limits flags: */
/*            if INFIN(I) < 0, Ith limits are (-infinity, infinity); */
/*            if INFIN(I) = 0, Ith limits are (-infinity, UPPER(I)]; */
/*            if INFIN(I) = 1, Ith limits are [LOWER(I), infinity); */
/*            if INFIN(I) = 2, Ith limits are [LOWER(I), UPPER(I)]. */
/*     CORREL REAL, array of correlation coefficients; the correlation */
/*            coefficient in row I column J of the correlation matrix */
/*            should be stored in CORREL( J + ((I-2)*(I-1))/2 ), for J < I. */
/*     MAXPTS INTEGER, maximum number of function values allowed. This */
/*            parameter can be used to limit the time. A sensible */
/*            strategy is to start with MAXPTS = 1000*N, and then */
/*            increase MAXPTS if ERROR is too large. */
/*     ABSEPS REAL absolute error tolerance. */
/*     RELEPS REAL relative error tolerance. */
/*     ERROR  REAL, estimated absolute error, with 99% confidence level. */
/*     VALUE  REAL, estimated value for the integral */
/*     INFORM INTEGER, termination status parameter: */
/*            if INFORM = 0, normal completion with ERROR < EPS; */
/*            if INFORM = 1, completion with ERROR > EPS and MAXPTS */
/*                           function vaules used; increase MAXPTS to */
/*                           decrease ERROR; */
/*            if INFORM = 2, N > 50. */

    /* Parameter adjustments */
    --correl;
    --infin;
    --upper;
    --lower;

    /* Function Body */
    if (*n > 50) {
	*inform__ = 2;
	*value = 0.;
	*error = 1.;
	return 0;
    }
    *inform__ = (integer) spmvti_(n, nu, &correl[1], &lower[1], &upper[1], &
	    infin[1], &infis, &d__, &e, &ns);
    if (*n - infis == 0) {
	*value = 1.;
	*error = 0.;
    } else if (*n - infis == 1) {
	*value = e - d__;
	*error = 2e-16f;
    } else {

/*        Call the Monte-Carlo integration subroutine */

/* Computing 3rd power */
	i__1 = *n;
	mpt = ns / (i__1 * (i__1 * i__1)) + 25;
	i__1 = *n - infis;
	tcrude_(&i__1, &mpt, error, value, &c__0);
	ivls = mpt * ns;
L10:
/* Computing MAX */
	d__1 = *abseps, d__2 = *releps * abs(*value);
	eps = max(d__1,d__2);
	if (*error > eps && ivls < *maxpts) {
/* Computing MAX */
/* Computing MIN */
/* Computing 2nd power */
	    d__1 = *error / eps;
	    i__2 = (integer) (mpt * (d__1 * d__1)), i__3 = (*maxpts - ivls) / 
		    ns;
	    i__1 = min(i__2,i__3);
	    mpt = max(i__1,10);
	    i__1 = *n - infis;
	    tcrude_(&i__1, &mpt, error, value, &c__1);
	    ivls += mpt * ns;
	    goto L10;
	}
	if (*error > eps && ivls >= *maxpts) {
	    *inform__ = 1;
	}
    }
    return 0;
} /* sphmvt_ */

doublereal spmvt_0_(int n__, integer *n, integer *nuin, doublereal *correl, 
	doublereal *lower, doublereal *upper, integer *infin, integer *infis, 
	doublereal *d__, doublereal *e, integer *nso)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal ret_val, d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer infi[50];
    extern doublereal rnor_(void);
    static doublereal a[50], b[50];
    static integer i__, j, k;
    static doublereal u[2500]	/* was [50][50] */, y[50];
    static integer ic[50], ii, ij;
    static doublereal bt;
    static integer is[50], ns, nu;
    static doublereal rs;
    extern /* Subroutine */ int rcswap_(integer *, integer *, doublereal *, 
	    doublereal *, integer *, integer *, doublereal *);
    extern doublereal sphlmt_(integer *, integer *, doublereal *, doublereal *
	    , integer *, doublereal *);
    extern /* Subroutine */ int mvtlms_(integer *, doublereal *, doublereal *,
	     integer *, doublereal *, doublereal *);
    static doublereal cov[1275], tmp;


/*     Integrand subroutine */


/*    First generate U = COV*(random orthogonal matrix) */

    /* Parameter adjustments */
    if (correl) {
	--correl;
	}
    if (lower) {
	--lower;
	}
    if (upper) {
	--upper;
	}
    if (infin) {
	--infin;
	}

    /* Function Body */
    switch(n__) {
	case 1: goto L_spmvti;
	}

    for (k = *n - 1; k >= 1; --k) {
	tmp = 0.;
	i__1 = *n;
	for (j = k; j <= i__1; ++j) {
	    y[j - 1] = rnor_();
/* Computing 2nd power */
	    d__1 = y[j - 1];
	    tmp += d__1 * d__1;
	}
	tmp = -sqrt(tmp);
	bt = 1 / (tmp * (y[k - 1] + tmp));
	y[k - 1] += tmp;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    tmp = 0.;
	    i__2 = *n;
	    for (j = k; j <= i__2; ++j) {
		tmp += u[i__ + j * 50 - 51] * y[j - 1];
	    }
	    tmp = bt * tmp;
	    i__2 = *n;
	    for (j = k; j <= i__2; ++j) {
		u[i__ + j * 50 - 51] -= tmp * y[j - 1];
	    }
	}
    }

/*     Compute integrand average */

    rs = sqrt(2.);
    for (i__ = 1; i__ <= 2; ++i__) {
	ic[i__ - 1] = i__;
    }
    ic[2] = *n + 1;
    ret_val = 0.;
    ns = 0;
L10:
    for (i__ = 1; i__ <= 2; ++i__) {
	is[i__ - 1] = -1;
    }
L20:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	tmp = 0.;
	for (j = 1; j <= 2; ++j) {
	    tmp += is[j - 1] * u[i__ + ic[j - 1] * 50 - 51];
	}
	y[i__ - 1] = tmp / rs;
    }
    ++ns;
    ret_val += (sphlmt_(n, &nu, a, b, infi, y) - ret_val) / ns;
    for (i__ = 1; i__ <= 2; ++i__) {
	is[i__ - 1] += 2;
	if (is[i__ - 1] < 2) {
	    goto L20;
	}
	is[i__ - 1] = -1;
    }
    for (i__ = 1; i__ <= 2; ++i__) {
	++ic[i__ - 1];
	if (ic[i__ - 1] < ic[i__]) {
	    goto L10;
	}
	ic[i__ - 1] = i__;
    }
    ret_val /= 2;
    return ret_val;


L_spmvti:
    ret_val = 0.;
    nu = *nuin;

/*     Initialisation */

    ii = 0;
    ij = 0;
    *infis = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	infi[i__ - 1] = infin[i__];
	if (infi[i__ - 1] < 0) {
	    ++(*infis);
	} else {
	    a[i__ - 1] = 0.;
	    b[i__ - 1] = 0.;
	    if (infi[i__ - 1] != 0) {
		a[i__ - 1] = lower[i__];
	    }
	    if (infi[i__ - 1] != 1) {
		b[i__ - 1] = upper[i__];
	    }
	}
	i__2 = i__ - 1;
	for (j = 1; j <= i__2; ++j) {
	    ++ii;
	    ++ij;
	    cov[ij - 1] = correl[ii];
	}
	++ij;
	cov[ij - 1] = 1.;
    }
    *nso = 1;
    for (i__ = 1; i__ <= 2; ++i__) {
	*nso = (*nso << 1) * (*n - *infis - i__ + 1) / i__;
    }

/*     First move any doubly infinite limits to innermost positions */

    if (*infis < *n) {
	i__1 = *n - *infis + 1;
	for (i__ = *n; i__ >= i__1; --i__) {
	    if (infi[i__ - 1] >= 0) {
		i__2 = i__ - 1;
		for (j = 1; j <= i__2; ++j) {
		    if (infi[j - 1] < 0) {
			rcswap_(&j, &i__, a, b, infi, n, cov);
			goto L30;
		    }
		}
	    }
L30:
	    ;
	}
    }
    ii = 0;
    i__1 = *n - *infis;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = i__;
	for (j = 1; j <= i__2; ++j) {
	    u[j + i__ * 50 - 51] = 0.;
	    ++ii;
	    u[i__ + j * 50 - 51] = cov[ii - 1];
	}
    }

/*     Determine Cholesky decomposition */

    i__1 = *n - *infis;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *n - *infis;
	for (i__ = j; i__ <= i__2; ++i__) {
	    tmp = u[i__ + j * 50 - 51];
	    i__3 = j - 1;
	    for (k = 1; k <= i__3; ++k) {
		tmp -= u[i__ + k * 50 - 51] * u[j + k * 50 - 51];
	    }
	    if (i__ == j) {
		u[j + j * 50 - 51] = sqrt((max(tmp,0.)));
	    } else if (u[i__ + i__ * 50 - 51] > 0.) {
		u[i__ + j * 50 - 51] = tmp / u[j + j * 50 - 51];
	    } else {
		u[i__ + j * 50 - 51] = 0.;
	    }
	}
    }
    i__1 = *n - *infis;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (u[i__ + i__ * 50 - 51] > 0.) {
	    if (infi[i__ - 1] != 0) {
		a[i__ - 1] /= u[i__ + i__ * 50 - 51];
	    }
	    if (infi[i__ - 1] != 1) {
		b[i__ - 1] /= u[i__ + i__ * 50 - 51];
	    }
	    i__2 = i__;
	    for (j = 1; j <= i__2; ++j) {
		u[i__ + j * 50 - 51] /= u[i__ + i__ * 50 - 51];
	    }
	}
    }
    mvtlms_(&nu, a, b, infi, d__, e);
    return ret_val;
} /* spmvt_ */

doublereal spmvt_(integer *n)
{
    return spmvt_0_(0, n, (integer *)0, (doublereal *)0, (doublereal *)0, (
	    doublereal *)0, (integer *)0, (integer *)0, (doublereal *)0, (
	    doublereal *)0, (integer *)0);
    }

doublereal spmvti_(integer *n, integer *nuin, doublereal *correl, doublereal *
	lower, doublereal *upper, integer *infin, integer *infis, doublereal *
	d__, doublereal *e, integer *nso)
{
    return spmvt_0_(1, n, nuin, correl, lower, upper, infin, infis, d__, e, 
	    nso);
    }

doublereal sphlmt_(integer *n, integer *nu, doublereal *a, doublereal *b, 
	integer *infi, doublereal *y)
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val, d__1, d__2;

    /* Local variables */
    static integer i__;
    extern doublereal sphnct_(integer *, integer *, doublereal *);
    static doublereal cmn, cmx;

    /* Parameter adjustments */
    --y;
    --infi;
    --b;
    --a;

    /* Function Body */
    cmn = (doublereal) (*n * -10);
    cmx = (doublereal) (*n * 10);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (y[i__] > 0.) {
	    if (infi[i__] != 1) {
/* Computing MIN */
		d__1 = cmx, d__2 = b[i__] / y[i__];
		cmx = min(d__1,d__2);
	    }
	    if (infi[i__] != 0) {
/* Computing MAX */
		d__1 = cmn, d__2 = a[i__] / y[i__];
		cmn = max(d__1,d__2);
	    }
	} else {
	    if (infi[i__] != 1) {
/* Computing MAX */
		d__1 = cmn, d__2 = b[i__] / y[i__];
		cmn = max(d__1,d__2);
	    }
	    if (infi[i__] != 0) {
/* Computing MIN */
		d__1 = cmx, d__2 = a[i__] / y[i__];
		cmx = min(d__1,d__2);
	    }
	}
    }
    if (cmn < cmx) {
	if (cmn >= 0. && cmx >= 0.) {
	    ret_val = sphnct_(n, nu, &cmx) - sphnct_(n, nu, &cmn);
	} else if (cmn < 0. && cmx >= 0.) {
	    d__1 = -cmn;
	    ret_val = sphnct_(n, nu, &d__1) + sphnct_(n, nu, &cmx);
	} else {
	    d__1 = -cmn;
	    d__2 = -cmx;
	    ret_val = sphnct_(n, nu, &d__1) - sphnct_(n, nu, &d__2);
	}
    } else {
	ret_val = 0.;
    }
    return ret_val;
} /* sphlmt_ */

/* Subroutine */ int tcrude_(integer *ndim, integer *maxpts, doublereal *
	absest, doublereal *finest, integer *ir)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer m;
    extern doublereal spmvt_(integer *);
    static doublereal findif, finval, varprd, varest, varsqr;


/*     Crude Monte-Carlo Algorithm for Deak method with */
/*      weighted results on restart */

    if (*ir <= 0) {
	varest = 0.;
	*finest = 0.;
    }
    finval = 0.;
    varsqr = 0.;
    i__1 = *maxpts;
    for (m = 1; m <= i__1; ++m) {
	findif = (spmvt_(ndim) - finval) / m;
	finval += findif;
/* Computing 2nd power */
	d__1 = findif;
	varsqr = (m - 2) * varsqr / m + d__1 * d__1;
    }
    varprd = varest * varsqr;
    *finest += (finval - *finest) / (varprd + 1);
    if (varsqr > 0.) {
	varest = (varprd + 1) / varsqr;
    }
    *absest = sqrt(varsqr / (varprd + 1)) * 3;
    return 0;
} /* tcrude_ */

doublereal sphnct_(integer *m, integer *nu, doublereal *r__)
{
    /* Initialized data */

    static integer nuold = 0;

    /* System generated locals */
    doublereal ret_val, d__1;

    /* Builtin functions */
    double sqrt(doublereal), pow_di(doublereal *, integer *);

    /* Local variables */
    static doublereal tcon;
    static integer i__;
    static doublereal pf, rr, rt;
    extern doublereal studnt_(integer *, doublereal *);


/*                   R */
/*     SPHNCT =  K  I  ( 1 + t**2/NU )**(-(NU+M)/2 ) t**(M-1) dt, for M > 0. */
/*                M  0 */

    if (*r__ > 0.) {
	if (*m <= 1) {
	    ret_val = studnt_(nu, r__) * 2 - 1;
	} else if (*m == 2) {
	    d__1 = sqrt(*r__ * *r__ / *nu + 1);
	    ret_val = 1 - 1 / pow_di(&d__1, nu);
	} else {
	    rr = *r__ * *r__ / *nu;
	    rt = rr / (rr + 1);
	    pf = 1.;
	    for (i__ = *m - 2; i__ >= 2; i__ += -2) {
		pf = pf * rt * (*nu + i__ - 2) / i__ + 1;
	    }
	    d__1 = sqrt(rt / rr);
	    pf *= pow_di(&d__1, nu);
	    if (*m % 2 == 0) {
		ret_val = 1 - pf;
	    } else {
		if (*nu != nuold) {
		    nuold = *nu;
		    tcon = 1.;
		    if (*nu % 2 == 0) {
			tcon /= 2;
		    } else {
			tcon /= 3.141592653589793;
		    }
		    for (i__ = *nu - 2; i__ >= 1; i__ += -2) {
			tcon = (i__ + 1) * tcon / i__;
		    }
		}
		ret_val = (studnt_(nu, r__) - tcon * sqrt(rt) * pf) * 2 - 1;
	    }
	}
    } else {
	ret_val = 0.;
    }
    return ret_val;
} /* sphnct_ */

doublereal rnor_(void)
{
    /* Initialized data */

    static doublereal v[65] = { .340945,.4573146,.5397793,.6062427,.6631691,
	    .7136975,.7596125,.8020356,.8417227,.8792102,.9148948,.9490791,
	    .9820005,1.0138492,1.044781,1.0749254,1.1043917,1.1332738,
	    1.161653,1.189601,1.2171815,1.2444516,1.2714635,1.298265,
	    1.3249008,1.3514125,1.3778399,1.4042211,1.4305929,1.4569915,
	    1.4834526,1.5100121,1.5367061,1.5635712,1.5906454,1.617968,
	    1.6455802,1.6735255,1.7018503,1.7306045,1.7598422,1.7896223,
	    1.8200099,1.851077,1.8829044,1.915583,1.9492166,1.9839239,
	    2.019843,2.0571356,2.095993,2.136645,2.1793713,2.2245175,
	    2.2725185,2.3239338,2.3795007,2.4402218,2.5075117,2.5834658,
	    2.6713916,2.7769943,2.7769943,2.7769943,2.7769943 };

    /* System generated locals */
    doublereal ret_val, d__1, d__2;

    /* Builtin functions */
    double exp(doublereal), d_sign(doublereal *, doublereal *), log(
	    doublereal);

    /* Local variables */
    static integer j;
    static doublereal s, x, y, vt;
    extern doublereal uni_(void);


/*       RNOR generates normal random numbers with zero mean and */
/*       unit standard deviation, often denoted N(0,1). */
/*       Adapted from RNOR in "Numerical Methods and Software" by */
/*                D. Kahaner, C. Moler, S. Nash */
/*                Prentice Hall, 1988 */

    y = uni_();
    j = (integer) (uni_() * 128) % 64 + 1;

/*     Pick sign as Y+Y-1 is positive or negative */

    vt = v[j];
    ret_val = (y + y - 1) * vt;
    if (abs(ret_val) > v[j - 1]) {
	x = (abs(ret_val) - v[j - 1]) / (vt - v[j - 1]);
	y = uni_();
	s = x + y;
	if (s > .9689279) {
/* Computing 2nd power */
	    d__1 = .4878992 - x * .4878992;
	    if (s > 1.301198 || y > 12.67706 - exp(-(d__1 * d__1) / 2) * 
		    12.37586) {
		d__1 = .4878992 - x * .4878992;
		ret_val = d_sign(&d__1, &ret_val);
	    } else {
/* Computing 2nd power */
		d__1 = vt;
/* Computing 2nd power */
		d__2 = ret_val;
		if (exp(-(d__1 * d__1) / 2) + y * .01958303 / vt > exp(-(d__2 
			* d__2) / 2)) {
L10:
		    x = log(uni_()) * .3601016f;
/* Computing 2nd power */
		    d__1 = x;
		    if (log(uni_()) * -2 <= d__1 * d__1) {
			goto L10;
		    }
		    d__1 = 2.7769943 - x;
		    ret_val = d_sign(&d__1, &ret_val);
		}
	    }
	}
    }
    return ret_val;
} /* rnor_ */


doublereal fncmvt_0_(int n__, integer *n, doublereal *w, integer *nuin, 
	doublereal *correl, doublereal *lower, doublereal *upper, integer *
	infin, integer *infis, doublereal *d__, doublereal *e)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal ret_val, d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer infi[20];
    static doublereal prod, a[20], b[20];
    static integer i__, j;
    static doublereal y[20], d1, e1, di, ei;
    static integer ij;
    static doublereal yd, ui;
    static integer nu;
    extern doublereal stdinv_(integer *, doublereal *);
    extern /* Subroutine */ int mvtlms_(integer *, doublereal *, doublereal *,
	     integer *, doublereal *, doublereal *), mvtsrt_(integer *, 
	    integer *, doublereal *, doublereal *, doublereal *, integer *, 
	    doublereal *, integer *, doublereal *, doublereal *, integer *, 
	    doublereal *, doublereal *, doublereal *);
    static doublereal cov[210], sum;


/*     Integrand subroutine */

    /* Parameter adjustments */
    if (w) {
	--w;
	}
    if (correl) {
	--correl;
	}
    if (lower) {
	--lower;
	}
    if (upper) {
	--upper;
	}
    if (infin) {
	--infin;
	}

    /* Function Body */
    switch(n__) {
	case 1: goto L_mvtnit;
	}

    di = d1;
    ei = e1;
    prod = ei - di;
    ij = 1;
    yd = 1.;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = nu + i__ - 1;
	d__1 = di + w[i__] * (ei - di);
	ui = stdinv_(&i__2, &d__1);
	y[i__ - 1] = ui / yd;
	yd /= sqrt((ui - 1) * (ui + 1) / (nu + i__) + 1);
	sum = 0.;
	i__2 = i__;
	for (j = 1; j <= i__2; ++j) {
	    ++ij;
	    sum += cov[ij - 1] * y[j - 1];
	}
	++ij;
	i__2 = nu + i__;
	d__1 = (a[i__] - sum) * yd;
	d__2 = (b[i__] - sum) * yd;
	mvtlms_(&i__2, &d__1, &d__2, &infi[i__], &di, &ei);
	prod *= ei - di;
    }
    ret_val = prod;
    return ret_val;

/*     Entry point for intialization */


L_mvtnit:
    ret_val = 0.;

/*     Initialization and computation of covariance matrix Cholesky factor */

    mvtsrt_(n, nuin, &lower[1], &upper[1], &correl[1], &infin[1], y, infis, a,
	     b, infi, cov, d__, e);
    nu = *nuin;
    d1 = *d__;
    e1 = *e;
    return ret_val;
} /* fncmvt_ */

doublereal fncmvt_(integer *n, doublereal *w)
{
    return fncmvt_0_(0, n, w, (integer *)0, (doublereal *)0, (doublereal *)0, 
	    (doublereal *)0, (integer *)0, (integer *)0, (doublereal *)0, (
	    doublereal *)0);
    }

doublereal mvtnit_(integer *n, integer *nuin, doublereal *correl, doublereal *
	lower, doublereal *upper, integer *infin, integer *infis, doublereal *
	d__, doublereal *e)
{
    return fncmvt_0_(1, n, (doublereal *)0, nuin, correl, lower, upper, infin,
	     infis, d__, e);
    }

/* Subroutine */ int mvtlms_(integer *nu, doublereal *a, doublereal *b, 
	integer *infin, doublereal *lower, doublereal *upper)
{
    extern doublereal studnt_(integer *, doublereal *);

    *lower = 0.;
    *upper = 1.;
    if (*infin >= 0) {
	if (*infin != 0) {
	    *lower = studnt_(nu, a);
	}
	if (*infin != 1) {
	    *upper = studnt_(nu, b);
	}
    }
    return 0;
} /* mvtlms_ */

/* Subroutine */ int mvtsrt_(integer *n, integer *nu, doublereal *lower, 
	doublereal *upper, doublereal *correl, integer *infin, doublereal *y, 
	integer *infis, doublereal *a, doublereal *b, integer *infi, 
	doublereal *cov, doublereal *d__, doublereal *e)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double sqrt(doublereal), pow_dd(doublereal *, doublereal *);

    /* Local variables */
    static doublereal amin, bmin, dmin__, emin;
    static integer jmin, i__, j, k;
    static doublereal sumsq, ai, bi;
    static integer ii, ij;
    static doublereal cvdiag, yd, yl, conodd, yu, conevn;
    extern /* Subroutine */ int rcswap_(integer *, integer *, doublereal *, 
	    doublereal *, integer *, integer *, doublereal *), mvtlms_(
	    integer *, doublereal *, doublereal *, integer *, doublereal *, 
	    doublereal *);
    static doublereal con, sum;


/*     Sort limits */

    /* Parameter adjustments */
    --cov;
    --infi;
    --b;
    --a;
    --y;
    --infin;
    --correl;
    --upper;
    --lower;

    /* Function Body */
    ij = 0;
    ii = 0;
    *infis = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	infi[i__] = infin[i__];
	if (infi[i__] < 0) {
	    ++(*infis);
	} else {
	    a[i__] = 0.;
	    b[i__] = 0.;
	    if (infi[i__] != 0) {
		a[i__] = lower[i__];
	    }
	    if (infi[i__] != 1) {
		b[i__] = upper[i__];
	    }
	}
	i__2 = i__ - 1;
	for (j = 1; j <= i__2; ++j) {
	    ++ij;
	    ++ii;
	    cov[ij] = correl[ii];
	}
	++ij;
	cov[ij] = 1.;
    }
    conodd = .31830988618379069;
    conevn = .5;
    i__1 = *nu - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (i__ % 2 == 0) {
	    if (i__ > 2) {
		conevn = conevn * (i__ - 1) / (i__ - 2);
	    }
	} else {
	    if (i__ > 2) {
		conodd = conodd * (i__ - 1) / (i__ - 2);
	    }
	}
    }

/*     First move any doubly infinite limits to innermost positions */

    if (*infis < *n) {
	i__1 = *n - *infis + 1;
	for (i__ = *n; i__ >= i__1; --i__) {
	    if (infi[i__] >= 0) {
		i__2 = i__ - 1;
		for (j = 1; j <= i__2; ++j) {
		    if (infi[j] < 0) {
			rcswap_(&j, &i__, &a[1], &b[1], &infi[1], n, &cov[1]);
			goto L10;
		    }
		}
	    }
L10:
	    ;
	}

/*     Sort remaining limits and determine Cholesky decomposition */

	ii = 0;
	yd = 1.;
	i__1 = *n - *infis;
	for (i__ = 1; i__ <= i__1; ++i__) {

/*     Determine the integration limits for variable with minimum */
/*      expected probability and interchange that variable with Ith. */

	    emin = 1.;
	    dmin__ = 0.;
	    jmin = i__;
	    cvdiag = 0.;
	    ij = ii;
	    i__2 = *n - *infis;
	    for (j = i__; j <= i__2; ++j) {
		sum = 0.;
		sumsq = 0.;
		i__3 = i__ - 1;
		for (k = 1; k <= i__3; ++k) {
		    sum += cov[ij + k] * y[k];
/* Computing 2nd power */
		    d__1 = cov[ij + k];
		    sumsq += d__1 * d__1;
		}
		ij += j;
/* Computing MAX */
		d__1 = cov[ij] - sumsq;
		sumsq = sqrt((max(d__1,0.)));
		if (sumsq > 0.) {
		    ai = yd * (a[j] - sum) / sumsq;
		    bi = yd * (b[j] - sum) / sumsq;
		    i__3 = *nu + j - 1;
		    mvtlms_(&i__3, &ai, &bi, &infi[j], d__, e);
		    if (emin - dmin__ >= *e - *d__) {
			jmin = j;
			amin = ai;
			bmin = bi;
			dmin__ = *d__;
			emin = *e;
			cvdiag = sumsq;
		    }
		}
	    }
	    if (jmin != i__) {
		rcswap_(&i__, &jmin, &a[1], &b[1], &infi[1], n, &cov[1]);
	    }

/*     Compute Ith column of Cholesky factor. */

	    ij = ii + i__;
	    cov[ij] = cvdiag;
	    i__2 = *n - *infis;
	    for (j = i__ + 1; j <= i__2; ++j) {
		if (cvdiag > 0.) {
		    sum = cov[ij + i__];
		    i__3 = i__ - 1;
		    for (k = 1; k <= i__3; ++k) {
			sum -= cov[ii + k] * cov[ij + k];
		    }
		    cov[ij + i__] = sum / cvdiag;
		} else {
		    cov[ij + i__] = 0.;
		}
		ij += j;
	    }

/*     Compute expected value for Ith integration variable and */
/*     scale Ith covariance matrix row and limits. */

	    if ((*nu + i__ - 1) % 2 == 0) {
		if (*nu + i__ - 3 > 0) {
		    conevn = conevn * (*nu + i__ - 2) / (*nu + i__ - 3);
		}
		con = conevn;
	    } else {
		if (*nu + i__ - 3 > 0) {
		    conodd = conodd * (*nu + i__ - 2) / (*nu + i__ - 3);
		}
		con = conodd;
	    }
	    if (cvdiag > 0.) {
		yl = 0.;
		yu = 0.;
		if (infi[i__] != 0 && *nu + i__ - 2 > 0) {
/* Computing 2nd power */
		    d__2 = amin;
		    d__1 = d__2 * d__2 / (*nu + i__ - 1) + 1;
		    d__3 = (*nu + i__ - 2) / 2.;
		    yl = -con * (*nu + i__ - 1) / (*nu + i__ - 2) / pow_dd(&
			    d__1, &d__3);
		}
		if (infi[i__] != 1 && *nu + i__ - 2 > 0) {
/* Computing 2nd power */
		    d__2 = bmin;
		    d__1 = d__2 * d__2 / (*nu + i__ - 1) + 1;
		    d__3 = (*nu + i__ - 2) / 2.;
		    yu = -con * (*nu + i__ - 1) / (*nu + i__ - 2) / pow_dd(&
			    d__1, &d__3);
		}
		y[i__] = (yu - yl) / (emin - dmin__) / yd;
		i__2 = i__;
		for (j = 1; j <= i__2; ++j) {
		    ++ii;
		    cov[ii] /= cvdiag;
		}
		if (infi[i__] != 0) {
		    a[i__] /= cvdiag;
		}
		if (infi[i__] != 1) {
		    b[i__] /= cvdiag;
		}
	    } else {
		y[i__] = 0.;
		ii += i__;
	    }
	    yd /= sqrt((y[i__] * yd + 1) * (y[i__] * yd - 1) / (*nu + i__) + 
		    1);
	}
	mvtlms_(nu, &a[1], &b[1], &infi[1], d__, e);
    }
    return 0;
} /* mvtsrt_ */

/* Subroutine */ int rcswap_(integer *p, integer *q, doublereal *a, 
	doublereal *b, integer *infin, integer *n, doublereal *c__)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__, j;
    static doublereal t;
    static integer ii, jj;


/*     Swaps rows and columns P and Q in situ. */

    /* Parameter adjustments */
    --c__;
    --infin;
    --b;
    --a;

    /* Function Body */
    t = a[*p];
    a[*p] = a[*q];
    a[*q] = t;
    t = b[*p];
    b[*p] = b[*q];
    b[*q] = t;
    j = infin[*p];
    infin[*p] = infin[*q];
    infin[*q] = j;
    jj = *p * (*p - 1) / 2;
    ii = *q * (*q - 1) / 2;
    t = c__[jj + *p];
    c__[jj + *p] = c__[ii + *q];
    c__[ii + *q] = t;
    i__1 = *p - 1;
    for (j = 1; j <= i__1; ++j) {
	t = c__[jj + j];
	c__[jj + j] = c__[ii + j];
	c__[ii + j] = t;
    }
    jj += *p;
    i__1 = *q - 1;
    for (i__ = *p + 1; i__ <= i__1; ++i__) {
	t = c__[jj + *p];
	c__[jj + *p] = c__[ii + i__];
	c__[ii + i__] = t;
	jj += i__;
    }
    ii += *q;
    i__1 = *n;
    for (i__ = *q + 1; i__ <= i__1; ++i__) {
	t = c__[ii + *p];
	c__[ii + *p] = c__[ii + *q];
	c__[ii + *q] = t;
	ii += i__;
    }
    return 0;
} /* rcswap_ */

/* Subroutine */ int rancov_(integer *n, doublereal *cov, integer *ik)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j;
    static doublereal s, t;
    static integer ii;
    static doublereal sg;
    extern /* Subroutine */ int cholpd_(integer *, doublereal *);
    static doublereal rho;
    extern doublereal uni_(void);


/*     Generates random correlation matrix in situ */

    /* Parameter adjustments */
    --cov;

    /* Function Body */
    if (*ik == 0) {
	rho = uni_();
	ii = 0;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    i__2 = i__ - 1;
	    for (j = 1; j <= i__2; ++j) {
		cov[ii + j] = rho;
	    }
	    ii += i__;
	    cov[ii] = 1.;
	}
    } else {
	ii = 0;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    s = 0.;
	    i__2 = i__;
	    for (j = 1; j <= i__2; ++j) {
		t = uni_() * 2 - 1;
		cov[ii + j] = t;
		s += t * t;
	    }
	    sg = 1.;
	    if (cov[ii + i__] < 0.) {
		sg = -1.;
	    }
	    s = sqrt(s);
	    i__2 = i__;
	    for (j = 1; j <= i__2; ++j) {
		cov[ii + j] = sg * cov[ii + j] / s;
	    }
	    ii += i__;
	}
	cholpd_(n, &cov[1]);
    }
    return 0;
} /* rancov_ */

/* Subroutine */ int cholpd_(integer *n, doublereal *choprd)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer i__, j, k;
    static doublereal s;
    static integer ii, kk, nn;


/*     Multiplies Choleski factors in situ */

    /* Parameter adjustments */
    --choprd;

    /* Function Body */
    nn = *n * (*n + 1) / 2;
    kk = nn;
    for (k = *n; k >= 1; --k) {
	kk -= k;
	ii = nn;
	i__1 = k;
	for (i__ = *n; i__ >= i__1; --i__) {
	    ii -= i__;
	    s = 0.;
	    i__2 = k;
	    for (j = 1; j <= i__2; ++j) {
		s += choprd[ii + j] * choprd[kk + j];
	    }
	    choprd[ii + k] = s;
	}
    }
    return 0;
} /* cholpd_ */

/* Subroutine */ int cholsk_(integer *n, doublereal *chofac)
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j, k;
    static doublereal s, t;
    static integer ii, jj;


/*     Computes Choleski factor in situ */

    /* Parameter adjustments */
    --chofac;

    /* Function Body */
    jj = 0;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	ii = jj;
	i__2 = *n;
	for (i__ = j; i__ <= i__2; ++i__) {
	    s = chofac[ii + j];
	    i__3 = j - 1;
	    for (k = 1; k <= i__3; ++k) {
		s -= chofac[ii + k] * chofac[jj + k];
	    }
	    if (i__ == j) {
		t = sqrt((max(s,0.)));
		chofac[ii + j] = t;
	    } else {
		chofac[ii + j] = s / t;
	    }
	    ii += i__;
	}
	jj += j;
    }
    return 0;
} /* cholsk_ */

doublereal studnt_(integer *nu, doublereal *t)
{
    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double atan(doublereal), sqrt(doublereal);

    /* Local variables */
    static integer j;
    static doublereal snthe, polyn, rn, ts, tt, cssthe;


/*     Student t Distribution Function */

/*                       T */
/*         STUDNT = C   I  ( 1 + y*y/NU )**( -(NU+1)/2 ) dy */
/*                   NU -INF */

    if (*nu == 1) {
	ret_val = (atan(*t) * 2 / 3.141592653589793 + 1) / 2;
    } else if (*nu == 2) {
	ret_val = (*t / sqrt(*t * *t + 2) + 1) / 2;
    } else {
	tt = *t * *t;
	cssthe = 1 / (tt / *nu + 1);
	polyn = 1.;
	for (j = *nu - 2; j >= 2; j += -2) {
	    polyn = (j - 1) * cssthe * polyn / j + 1;
	}
	if (*nu % 2 == 1) {
	    rn = (doublereal) (*nu);
	    ts = *t / sqrt(rn);
	    ret_val = ((atan(ts) + ts * cssthe * polyn) * 2 / 
		    3.141592653589793 + 1) / 2;
	} else {
	    snthe = *t / sqrt(*nu + tt);
	    ret_val = (snthe * polyn + 1) / 2;
	}
	ret_val = max(0.,ret_val);
    }
    return ret_val;
} /* studnt_ */

doublereal stdinv_(integer *n, doublereal *z__)
{
    /* System generated locals */
    doublereal ret_val, d__1, d__2;

    /* Builtin functions */
    double tan(doublereal), sqrt(doublereal), pow_dd(doublereal *, doublereal 
	    *), exp(doublereal);

    /* Local variables */
    static doublereal a, b, c__, d__, p, x, y;
    extern doublereal phinv_(doublereal *), stdjac_(integer *, doublereal *), 
	    studnt_(integer *, doublereal *);


/*     Inverse Student t Distribution Function */

/*                    STDINV */
/*           Z = C   I      (1 + y*y/N)**(-(N+1)/2) dy */
/*                N  -INF */

/*      Reference: G.W. Hill, Comm. ACM Algorithm 395 */
/*                 Comm. ACM 13 (1970), pp. 619-620. */

/*      Conversions to double precision and other modifications by */
/*                 Alan Genz, 1993-4. */

    if (0. < *z__ && *z__ < 1.) {
	if (*n == 1) {
	    ret_val = tan((*z__ * 2 - 1) * 3.141592653589793 / 2);
	} else if (*n == 2) {
	    ret_val = (*z__ * 2 - 1) / sqrt(*z__ * 2 * (1 - *z__));
	} else {
	    if (*z__ * 2 >= 1.) {
		p = (1 - *z__) * 2;
	    } else {
		p = *z__ * 2;
	    }
	    a = 1 / (*n - .5f);
	    b = 48 / (a * a);
	    c__ = ((a * 20700 / b - 98) * a - 16) * a + 96.36f;
	    d__ = ((94.5f / (b + c__) - 3) / b + 1) * sqrt(a * 
		    3.141592653589793 / 2) * *n;
	    x = d__ * p;
	    d__1 = 2. / *n;
	    y = pow_dd(&x, &d__1);
	    if (y > a + .05f) {
		d__1 = p / 2;
		x = phinv_(&d__1);
		y = x * x;
		if (*n < 5) {
		    c__ += (*n - 4.5f) * 3 * (x * 10 + 6) / 100;
		}
		c__ = (((d__ * x - 100) * x / 20 - 7) * x - 2) * x + b + c__;
		y = (((((y * 4 + 63) * y / 10 + 36) * y + 94.5f) / c__ - y - 
			3) / b + 1) * x;
		y = a * y * y;
		if (y > .002f) {
		    y = exp(y) - 1;
		} else {
		    y *= y / 2 + 1;
		}
	    } else {
		y = ((1 / (((*n + 6) / (*n * y) - d__ * .089f - .822f) * (*n *
			 3 + 6)) + .5f / (*n + 4)) * y - 1) * (*n + 1) / (*n 
			+ 2) + 1 / y;
	    }
	    ret_val = sqrt(*n * y);
	    if (*z__ * 2 < 1.) {
		ret_val = -ret_val;
	    }
	    if (abs(ret_val) > 0.) {

/*     Use one third order correction to the single precision result */

		x = ret_val;
		d__ = *z__ - studnt_(n, &x);
		ret_val = x + d__ * 2 / (2 / stdjac_(n, &x) - d__ * (*n + 1) /
			 (*n / x + x));
	    }
	}
    } else {

/*     Use cutoff values for Z near 0 or 1. */

	d__1 = sqrt(*n * 6.2831853071795862) * 2e-16;
	d__2 = 2. / *n;
	ret_val = sqrt(*n / pow_dd(&d__1, &d__2));
	if (*z__ * 2 < 1.) {
	    ret_val = -ret_val;
	}
    }
    return ret_val;
} /* stdinv_ */

doublereal stdjac_(integer *nu, doublereal *t)
{
    /* Initialized data */

    static doublereal nuold = 0.;

    /* System generated locals */
    integer i__1;
    doublereal ret_val, d__1;

    /* Builtin functions */
    double sqrt(doublereal), pow_di(doublereal *, integer *);

    /* Local variables */
    static integer j;
    static doublereal const__, tt;


/*     Student t Distribution Transformation Jacobean */

/*          T            STDINV(NU,T) */
/*         I  f(y) dy = I   f(STDINV(NU,Z) STDJAC(NU,STDINV(NU,Z)) dZ */
/*         -INF          0 */

    if (*nu == 1) {
	ret_val = (*t * *t + 1) * 3.141592653589793;
    } else if (*nu == 2) {
/* Computing 3rd power */
	d__1 = sqrt(*t * *t + 2);
	ret_val = d__1 * (d__1 * d__1);
    } else {
	if ((doublereal) (*nu) != nuold) {
	    nuold = (doublereal) (*nu);
	    if (*nu % 2 == 0) {
		const__ = sqrt(nuold) * 2;
	    } else {
		const__ = sqrt(nuold) * 3.141592653589793;
	    }
	    for (j = *nu - 2; j >= 1; j += -2) {
		const__ = j * const__ / (j + 1);
	    }
	}
	tt = *t * *t / *nu + 1;
	i__1 = (*nu + 1) / 2;
	ret_val = const__ * pow_di(&tt, &i__1);
	if (*nu % 2 == 0) {
	    ret_val *= sqrt(tt);
	}
    }
    return ret_val;
} /* stdjac_ */

doublereal phi_(doublereal *z__)
{
    /* System generated locals */
    doublereal ret_val, d__1;

    /* Builtin functions */
    double exp(doublereal);

    /* Local variables */
    static doublereal zabs, p, expntl;


/* 	Normal distribution probabilities accurate to 1.e-15. */
/* 	Z = no. of standard deviations from the mean. */

/*       Based upon algorithm 5666 for the error function, from: */
/*       Hart, J.F. et al, 'Computer Approximations', Wiley 1968 */

/*       Programmer: Alan Miller */

/* 	Latest revision - 30 March 1986 */


    zabs = abs(*z__);

/*     |Z| > 37 */

    if (zabs > 37.) {
	p = 0.;
    } else {

/*     |Z| <= 37 */

/* Computing 2nd power */
	d__1 = zabs;
	expntl = exp(-(d__1 * d__1) / 2);

/*     |Z| < CUTOFF = 10/SQRT(2) */

	if (zabs < 7.071067811865475) {
	    p = expntl * ((((((zabs * .03526249659989109 + .7003830644436881) 
		    * zabs + 6.37396220353165) * zabs + 33.912866078383) * 
		    zabs + 112.0792914978709) * zabs + 221.2135961699311) * 
		    zabs + 220.2068679123761) / (((((((zabs * 
		    .08838834764831844 + 1.755667163182642) * zabs + 
		    16.06417757920695) * zabs + 86.78073220294608) * zabs + 
		    296.5642487796737) * zabs + 637.3336333788311) * zabs + 
		    793.8265125199484) * zabs + 440.4137358247522);

/*     |Z| >= CUTOFF. */

	} else {
	    p = expntl / (zabs + 1 / (zabs + 2 / (zabs + 3 / (zabs + 4 / (
		    zabs + .65))))) / 2.506628274631001;
	}
    }
    if (*z__ > 0.) {
	p = 1 - p;
    }
    ret_val = p;
    return ret_val;
} /* phi_ */

doublereal phinv_(doublereal *p)
{
    /* System generated locals */
    doublereal ret_val, d__1, d__2;

    /* Builtin functions */
    double log(doublereal), sqrt(doublereal);

    /* Local variables */
    static doublereal q, r__;


/*     ALGORITHM AS241  APPL. STATIST. (1988) VOL. 37, NO. 3 */

/*     Produces the normal deviate Z corresponding to a given lower */
/*     tail area of P. */

/*     The hash sums below are the sums of the mantissas of the */
/*     coefficients.   They are included for use in checking */
/*     transcription. */


/*     Coefficients for P close to 0.5 */

/*     HASH SUM AB      55.88319 28806 14901 4439 */

/*     Coefficients for P not close to 0, 0.5 or 1. */

/* 	HASH SUM CD    49.33206 50330 16102 89036 */

/* 	Coefficients for P near 0 or 1. */

/*     HASH SUM EF      47.52583 31754 92896 71629 */

    q = (*p * 2 - 1) / 2;
    if (abs(q) <= .425) {
	r__ = .180625 - q * q;
	ret_val = q * (((((((r__ * 2509.0809287301226727 + 
		33430.575583588128105) * r__ + 67265.770927008700853) * r__ + 
		45921.953931549871457) * r__ + 13731.693765509461125) * r__ + 
		1971.5909503065514427) * r__ + 133.14166789178437745) * r__ + 
		3.387132872796366608) / (((((((r__ * 5226.495278852854561 + 
		28729.085735721942674) * r__ + 39307.89580009271061) * r__ + 
		21213.794301586595867) * r__ + 5394.1960214247511077) * r__ + 
		687.1870074920579083) * r__ + 42.313330701600911252) * r__ + 
		1);
    } else {
/* Computing MIN */
	d__1 = *p, d__2 = 1 - *p;
	r__ = min(d__1,d__2);
	if (r__ > 0.) {
	    r__ = sqrt(-log(r__));
	    if (r__ <= 5.) {
		r__ += -1.6;
		ret_val = (((((((r__ * 7.7454501427834140764e-4 + 
			.0227238449892691845833) * r__ + 
			.24178072517745061177) * r__ + 1.27045825245236838258)
			 * r__ + 3.64784832476320460504) * r__ + 
			5.7694972214606914055) * r__ + 4.6303378461565452959) 
			* r__ + 1.42343711074968357734) / (((((((r__ * 
			1.05075007164441684324e-9 + 5.475938084995344946e-4) *
			 r__ + .0151986665636164571966) * r__ + 
			.14810397642748007459) * r__ + .68976733498510000455) 
			* r__ + 1.6763848301838038494) * r__ + 
			2.05319162663775882187) * r__ + 1);
	    } else {
		r__ += -5.;
		ret_val = (((((((r__ * 2.01033439929228813265e-7 + 
			2.71155556874348757815e-5) * r__ + 
			.0012426609473880784386) * r__ + 
			.026532189526576123093) * r__ + .29656057182850489123)
			 * r__ + 1.7848265399172913358) * r__ + 
			5.4637849111641143699) * r__ + 6.6579046435011037772) 
			/ (((((((r__ * 2.04426310338993978564e-15 + 
			1.4215117583164458887e-7) * r__ + 
			1.8463183175100546818e-5) * r__ + 
			7.868691311456132591e-4) * r__ + 
			.0148753612908506148525) * r__ + 
			.13692988092273580531) * r__ + .59983220655588793769) 
			* r__ + 1);
	    }
	} else {
	    ret_val = 8.5f;
	}
	if (q < 0.) {
	    ret_val = -ret_val;
	}
    }
    return ret_val;
} /* phinv_ */


doublereal uni_(void)
{
    /* Initialized data */

    static integer x10 = 11111111;
    static integer x11 = 22222222;
    static integer x12 = 33333333;
    static integer x20 = 44444444;
    static integer x21 = 55555555;
    static integer x22 = 88888888;

    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    static integer h__, z__, p12, p13, p21, p23;


/*     Uniform (0, 1) random number generator */

/*     Reference: */
/*     L'Ecuyer, Pierre (1996), */
/*     "Combined Multiple Recursive Random Number Generators" */
/*     Operations Research 44, pp. 816-822. */


/*                 INVMP1 = 1/(M1+1) */

/*     Component 1 */

    h__ = x10 / 11714;
    p13 = (x10 - h__ * 11714) * 183326 - h__ * 2883;
    h__ = x11 / 33921;
    p12 = (x11 - h__ * 33921) * 63308 - h__ * 12979;
    if (p13 < 0) {
	p13 += 2147483647;
    }
    if (p12 < 0) {
	p12 += 2147483647;
    }
    x10 = x11;
    x11 = x12;
    x12 = p12 - p13;
    if (x12 < 0) {
	x12 += 2147483647;
    }

/*     Component 2 */

    h__ = x20 / 3976;
    p23 = (x20 - h__ * 3976) * 539608 - h__ * 2071;
    h__ = x22 / 24919;
    p21 = (x22 - h__ * 24919) * 86098 - h__ * 7417;
    if (p23 < 0) {
	p23 += 2145483479;
    }
    if (p21 < 0) {
	p21 += 2145483479;
    }
    x20 = x21;
    x21 = x22;
    x22 = p21 - p23;
    if (x22 < 0) {
	x22 += 2145483479;
    }

/*     Combination */

    z__ = x12 - x22;
    if (z__ <= 0) {
	z__ += 2147483647;
    }
    ret_val = z__ * 4.656612873077392578125e-10;
    return ret_val;
} /* uni_ */

